/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc;
using Swashbuckle.AspNetCore.Annotations;
using Swashbuckle.AspNetCore.SwaggerGen;
using Newtonsoft.Json;
using System.ComponentModel.DataAnnotations;
using IO.Swagger.Attributes;

using Microsoft.AspNetCore.Authorization;
using IO.Swagger.Models;

namespace IO.Swagger.Controllers
{ 
    /// <summary>
    /// 
    /// </summary>
    [ApiController]
    public class GPSTracestracksApiController : ControllerBase
    { 
        /// <summary>
        /// Download Async Results
        /// </summary>
        /// <remarks>The results will be available for download for upto 30 days by calling the API.</remarks>
        /// <param name="body"></param>
        /// <response code="200">200 response</response>
        [HttpPost]
        [Route("//route/download")]
        [ValidateModelState]
        [SwaggerOperation("RouteDownloadPost")]
        [SwaggerResponse(statusCode: 200, type: typeof(SyncResponse), description: "200 response")]
        public virtual IActionResult RouteDownloadPost([FromBody]Body1 body)
        { 
            //TODO: Uncomment the next line to return response 200 or use other options such as return this.NotFound(), return this.BadRequest(..), ...
            // return StatusCode(200, default(SyncResponse));

            string exampleJson = null;
            exampleJson = "{\n  \"summary\" : {\n    \"rates\" : {\n      \"CAD\" : 1.342395,\n      \"INR\" : 75.49545,\n      \"MXN\" : 21.748097,\n      \"USD\" : 1\n    },\n    \"departure_time\" : 1.551541566E9,\n    \"status\" : \"OK\"\n  },\n  \"route\" : {\n    \"costs\" : {\n      \"cash\" : false,\n      \"creditCard\" : false,\n      \"fuel\" : 4.31,\n      \"licensePlate\" : 3.69,\n      \"otherCost\" : 10,\n      \"prepaidCard\" : 2.46,\n      \"tag\" : 2.46\n    },\n    \"hasTolls\" : true,\n    \"tolls\" : [ {\n      \"cashCost\" : false,\n      \"creditCardCost\" : false,\n      \"currency\" : \"USD\",\n      \"discountCarDetails\" : false,\n      \"discountCarType\" : false,\n      \"discountTruckDetails\" : false,\n      \"discountTrucks\" : false,\n      \"height\" : \"No\",\n      \"id\" : 131030,\n      \"lat\" : 33.00225,\n      \"licensePlateCost\" : 2.01,\n      \"licensePlatePrimary\" : \"ZipCash\",\n      \"licensePlateSecondary\" : false,\n      \"lng\" : -96.77585,\n      \"name\" : \"Coit Main Lane Gantry (MLP7)\",\n      \"prepaidCardCost\" : 1.34,\n      \"road\" : \"President George Bush Tpke\",\n      \"state\" : \"Texas\",\n      \"tagCost\" : 1.34,\n      \"tagPriCost\" : 1.34,\n      \"tagPrimary\" : [ \"TxTAG\", \"TollTag\", \"EZ TAG\", \"K-Tag\" ],\n      \"tagSecCost\" : false,\n      \"tagSecondary\" : [ ],\n      \"type\" : \"barrier\"\n    }, {\n      \"cashCost\" : false,\n      \"creditCardCost\" : false,\n      \"currency\" : \"USD\",\n      \"discountCarDetails\" : false,\n      \"discountCarType\" : false,\n      \"discountTruckDetails\" : false,\n      \"discountTrucks\" : false,\n      \"height\" : \"No\",\n      \"id\" : 131030,\n      \"lat\" : 33.00225,\n      \"licensePlateCost\" : 2.01,\n      \"licensePlatePrimary\" : \"ZipCash\",\n      \"licensePlateSecondary\" : false,\n      \"lng\" : -96.77585,\n      \"name\" : \"Coit Main Lane Gantry (MLP7)\",\n      \"prepaidCardCost\" : 1.34,\n      \"road\" : \"President George Bush Tpke\",\n      \"state\" : \"Texas\",\n      \"tagCost\" : 1.34,\n      \"tagPriCost\" : 1.34,\n      \"tagPrimary\" : [ \"TxTAG\", \"TollTag\", \"EZ TAG\", \"K-Tag\" ],\n      \"tagSecCost\" : false,\n      \"tagSecondary\" : [ ],\n      \"type\" : \"barrier\"\n    } ]\n  },\n  \"status\" : \"OK\"\n}";
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<SyncResponse>(exampleJson)
            : default(SyncResponse);
            //TODO: Change the data returned
            return new ObjectResult(example);
        }

        /// <summary>
        /// Request
        /// </summary>
        /// <remarks>&lt;p&gt;This API can be used in synchronous and asynchronous modes. The default mode of operation is synchronous mode where the API response with toll information is returned immediately.&lt;/p&gt;&lt;p&gt;Asynchronous mode is used in the following cases: &lt;/p&gt;&lt;ul&gt; &lt;li&gt;Bulk upload of multiple GPS tracks files&lt;/li&gt;&lt;li&gt;Uploading large GPS tracks files&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;In asynchronous mode, the response is returned immediately with a &lt;code&gt;requestId&lt;/code&gt; and &lt;code&gt;requestedTimestamp&lt;/code&gt;. The results will be available for download for upto 30 days by calling the &lt;code&gt;route/download&lt;/code&gt; API. Asynchronous mode can used by specifying the url parameter &lt;code&gt;isAsync&#x3D;true&lt;/code&gt;.&lt;/p&gt;&lt;p&gt;GPS traces can be passed in the following format &lt;/p&gt;&lt;ul&gt; &lt;li&gt;Upload CSV file&lt;/li&gt;&lt;li&gt;Upload kml file&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;The first line in the CSV needs to contain the attribute names. The subsequent lines needs to contain the data in temporal order. The following parameters are available:&lt;/p&gt;&lt;table&gt;&lt;thead&gt;&lt;tr&gt;&lt;th&gt;Parameter&lt;/th&gt;&lt;th&gt;Description&lt;/th&gt;&lt;/tr&gt;&lt;/thead&gt;&lt;tbody&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;latitude&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;Latitude coordinate in WGS84 degree (mandatory)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;longitude&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;Longitude coordinate in WGS84 degree (mandatory)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;timestamp&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;indicates the time and date, for example&amp;nbsp;&amp;nbsp;2018-05-21T17:05:06Z (mandatory since tolls may change based on time)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;speed_mps&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;speed in meters per second (optional)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;speed_mph&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;speed in miles per hour (optional)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;speed_kmh&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;speed in kilometers per hour (optional)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;heading&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;heading in degrees clockwise from North (optional)&lt;/td&gt;&lt;/tr&gt;&lt;/tbody&gt;&lt;/table&gt;&lt;p&gt;You can download sample file from &lt;a href&#x3D;\&quot;https://tollguru-cdn.s3.us-east-2.amazonaws.com/trip_route.csv\&quot; target&#x3D;\&quot;_blank\&quot;&gt;here&lt;/a&gt;&lt;/p&gt;&lt;p&gt;Or use the CSV format file as shown in the table below:&lt;/p&gt;&lt;table&gt; &lt;tr&gt; &lt;th&gt;latitude&lt;/th&gt; &lt;th&gt;longitude&lt;/th&gt; &lt;th&gt;timestamp&lt;/th&gt; &lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.90479&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02607&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:45:23Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.90479&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02606&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:47:24Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.9048&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02608&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:49:25Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.9044&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02604&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:50:42Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.90424&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02646&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:50:49Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.90422&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02686&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:50:55Z&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</remarks>
        /// <param name="vehicleType"></param>
        /// <param name="vehicleName">Specify name for your vehicle to identify the response json for particular vehicle</param>
        /// <param name="height">Specify the vehicle height to get accurate tolls for toll roads where tolls depend on axles and vehicle height</param>
        /// <param name="weight">Specify the vehicle weight to get accurate tolls for toll roads where tolls depend on axles and vehicle weight</param>
        /// <param name="isAsync">The API will function in asynchronous mode is set to true</param>
        /// <param name="body"></param>
        /// <response code="200">200 response</response>
        [HttpPost]
        [Route("//route/upload")]
        [ValidateModelState]
        [SwaggerOperation("RouteUploadPost")]
        [SwaggerResponse(statusCode: 200, type: typeof(Object), description: "200 response")]
        public virtual IActionResult RouteUploadPost([FromQuery][Required()]string vehicleType, [FromQuery]string vehicleName, [FromQuery]string height, [FromQuery]string weight, [FromQuery]bool? isAsync, [FromBody]byte[] body)
        { 
            //TODO: Uncomment the next line to return response 200 or use other options such as return this.NotFound(), return this.BadRequest(..), ...
            // return StatusCode(200, default(Object));

            string exampleJson = null;
            exampleJson = "\"\"";
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<Object>(exampleJson)
            : default(Object);
            //TODO: Change the data returned
            return new ObjectResult(example);
        }
    }
}
