/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc;
using Swashbuckle.AspNetCore.Annotations;
using Swashbuckle.AspNetCore.SwaggerGen;
using Newtonsoft.Json;
using System.ComponentModel.DataAnnotations;
using IO.Swagger.Attributes;

using Microsoft.AspNetCore.Authorization;
using IO.Swagger.Models;

namespace IO.Swagger.Controllers
{ 
    /// <summary>
    /// 
    /// </summary>
    [ApiController]
    public class RoutePolylineApiController : ControllerBase
    { 
        /// <summary>
        /// Route polyline (from HERE/ Google map)
        /// </summary>
        /// <remarks>The response endpoint retrieves all tolls on the single route requested. You will not receive tolls for alternate routes possible between the origin and destination.</remarks>
        /// <param name="body"></param>
        /// <response code="200">200 response</response>
        [HttpPost]
        [Route("//route")]
        [ValidateModelState]
        [SwaggerOperation("RoutePost")]
        [SwaggerResponse(statusCode: 200, type: typeof(InlineResponse200), description: "200 response")]
        public virtual IActionResult RoutePost([FromBody]Body body)
        { 
            //TODO: Uncomment the next line to return response 200 or use other options such as return this.NotFound(), return this.BadRequest(..), ...
            // return StatusCode(200, default(InlineResponse200));

            string exampleJson = null;
            exampleJson = "{\n  \"summary\" : {\n    \"rates\" : {\n      \"CAD\" : 1.342395,\n      \"INR\" : 75.49545,\n      \"MXN\" : 21.748097,\n      \"USD\" : 1\n    },\n    \"departure_time\" : 1.551541566E9,\n    \"status\" : \"OK\"\n  },\n  \"route\" : {\n    \"costs\" : {\n      \"cash\" : false,\n      \"creditCard\" : false,\n      \"fuel\" : 4.31,\n      \"licensePlate\" : 3.69,\n      \"otherCost\" : 10,\n      \"prepaidCard\" : 2.46,\n      \"tag\" : 2.46\n    },\n    \"hasTolls\" : true,\n    \"tolls\" : [ {\n      \"cashCost\" : false,\n      \"creditCardCost\" : false,\n      \"currency\" : \"USD\",\n      \"discountCarDetails\" : false,\n      \"discountCarType\" : false,\n      \"discountTruckDetails\" : false,\n      \"discountTrucks\" : false,\n      \"height\" : \"No\",\n      \"id\" : 131030,\n      \"lat\" : 33.00225,\n      \"licensePlateCost\" : 2.01,\n      \"licensePlatePrimary\" : \"ZipCash\",\n      \"licensePlateSecondary\" : false,\n      \"lng\" : -96.77585,\n      \"name\" : \"Coit Main Lane Gantry (MLP7)\",\n      \"prepaidCardCost\" : 1.34,\n      \"road\" : \"President George Bush Tpke\",\n      \"state\" : \"Texas\",\n      \"tagCost\" : 1.34,\n      \"tagPriCost\" : 1.34,\n      \"tagPrimary\" : [ \"TxTAG\", \"TollTag\", \"EZ TAG\", \"K-Tag\" ],\n      \"tagSecCost\" : false,\n      \"tagSecondary\" : [ ],\n      \"type\" : \"barrier\"\n    }, {\n      \"cashCost\" : false,\n      \"creditCardCost\" : false,\n      \"currency\" : \"USD\",\n      \"discountCarDetails\" : false,\n      \"discountCarType\" : false,\n      \"discountTruckDetails\" : false,\n      \"discountTrucks\" : false,\n      \"height\" : \"No\",\n      \"id\" : 131030,\n      \"lat\" : 33.00225,\n      \"licensePlateCost\" : 2.01,\n      \"licensePlatePrimary\" : \"ZipCash\",\n      \"licensePlateSecondary\" : false,\n      \"lng\" : -96.77585,\n      \"name\" : \"Coit Main Lane Gantry (MLP7)\",\n      \"prepaidCardCost\" : 1.34,\n      \"road\" : \"President George Bush Tpke\",\n      \"state\" : \"Texas\",\n      \"tagCost\" : 1.34,\n      \"tagPriCost\" : 1.34,\n      \"tagPrimary\" : [ \"TxTAG\", \"TollTag\", \"EZ TAG\", \"K-Tag\" ],\n      \"tagSecCost\" : false,\n      \"tagSecondary\" : [ ],\n      \"type\" : \"barrier\"\n    } ]\n  }\n}";
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<InlineResponse200>(exampleJson)
            : default(InlineResponse200);
            //TODO: Change the data returned
            return new ObjectResult(example);
        }
    }
}
