/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{ 
    /// <summary>
    /// 
    /// </summary>
    [DataContract]
    public partial class Body : IEquatable<Body>
    { 
        /// <summary>
        /// Gets or Sets DepartureTime
        /// </summary>
        [DataMember(Name="departure_time")]
        public Object DepartureTime { get; set; }

        /// <summary>
        /// Specify route as a set of comma-separated &lt;strong&gt;&lt;code&gt;lat,lng&lt;/code&gt;&lt;/strong&gt; coordinates delimited by a pipe character (|)
        /// </summary>
        /// <value>Specify route as a set of comma-separated &lt;strong&gt;&lt;code&gt;lat,lng&lt;/code&gt;&lt;/strong&gt; coordinates delimited by a pipe character (|)</value>
        [DataMember(Name="path")]
        public string Path { get; set; }

        /// <summary>
        /// Specify route as Google Maps encoded polyline (&lt;a href&#x3D;\&quot;https://developers.google.com/maps/documentation/utilities/polylinealgorithm\&quot; target&#x3D;\&quot;_blank\&quot;&gt;see details&lt;/a&gt;)
        /// </summary>
        /// <value>Specify route as Google Maps encoded polyline (&lt;a href&#x3D;\&quot;https://developers.google.com/maps/documentation/utilities/polylinealgorithm\&quot; target&#x3D;\&quot;_blank\&quot;&gt;see details&lt;/a&gt;)</value>
        [DataMember(Name="polyline")]
        public string Polyline { get; set; }

        /// <summary>
        /// Specify route source, either <code>here</code> for HERE maps routes based polyline or <code>gmaps</code> for Google Maps polylines
        /// </summary>
        /// <value>Specify route source, either <code>here</code> for HERE maps routes based polyline or <code>gmaps</code> for Google Maps polylines</value>
        [JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
        public enum SourceEnum
        {
            
            /// <summary>
            /// Enum HereEnum for here
            /// </summary>
            [EnumMember(Value = "here")]
            HereEnum = 1,
            
            /// <summary>
            /// Enum GmapEnum for gmap
            /// </summary>
            [EnumMember(Value = "gmap")]
            GmapEnum = 2
        }

        /// <summary>
        /// Specify route source, either &lt;code&gt;here&lt;/code&gt; for HERE maps routes based polyline or &lt;code&gt;gmaps&lt;/code&gt; for Google Maps polylines
        /// </summary>
        /// <value>Specify route source, either &lt;code&gt;here&lt;/code&gt; for HERE maps routes based polyline or &lt;code&gt;gmaps&lt;/code&gt; for Google Maps polylines</value>
        [DataMember(Name="source")]
        public SourceEnum? Source { get; set; }

        /// <summary>
        /// Gets or Sets VehicleType
        /// </summary>
        [DataMember(Name="vehicleType")]
        public VehicleType VehicleType { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Body {\n");
            sb.Append("  DepartureTime: ").Append(DepartureTime).Append("\n");
            sb.Append("  Path: ").Append(Path).Append("\n");
            sb.Append("  Polyline: ").Append(Polyline).Append("\n");
            sb.Append("  Source: ").Append(Source).Append("\n");
            sb.Append("  VehicleType: ").Append(VehicleType).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            return obj.GetType() == GetType() && Equals((Body)obj);
        }

        /// <summary>
        /// Returns true if Body instances are equal
        /// </summary>
        /// <param name="other">Instance of Body to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Body other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    DepartureTime == other.DepartureTime ||
                    DepartureTime != null &&
                    DepartureTime.Equals(other.DepartureTime)
                ) && 
                (
                    Path == other.Path ||
                    Path != null &&
                    Path.Equals(other.Path)
                ) && 
                (
                    Polyline == other.Polyline ||
                    Polyline != null &&
                    Polyline.Equals(other.Polyline)
                ) && 
                (
                    Source == other.Source ||
                    Source != null &&
                    Source.Equals(other.Source)
                ) && 
                (
                    VehicleType == other.VehicleType ||
                    VehicleType != null &&
                    VehicleType.Equals(other.VehicleType)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                var hashCode = 41;
                // Suitable nullity checks etc, of course :)
                    if (DepartureTime != null)
                    hashCode = hashCode * 59 + DepartureTime.GetHashCode();
                    if (Path != null)
                    hashCode = hashCode * 59 + Path.GetHashCode();
                    if (Polyline != null)
                    hashCode = hashCode * 59 + Polyline.GetHashCode();
                    if (Source != null)
                    hashCode = hashCode * 59 + Source.GetHashCode();
                    if (VehicleType != null)
                    hashCode = hashCode * 59 + VehicleType.GetHashCode();
                return hashCode;
            }
        }

        #region Operators
        #pragma warning disable 1591

        public static bool operator ==(Body left, Body right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(Body left, Body right)
        {
            return !Equals(left, right);
        }

        #pragma warning restore 1591
        #endregion Operators
    }
}
