/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{ 
    /// <summary>
    /// &lt;p&gt;Costs object summarizes the toll cost and the fuel cost for the route.The fuel costs calculated from fuel efficiency (city fuel effiency and highway fuel efficiency) and the speeds on each leg of the route.&lt;/p&gt;&lt;p&gt;The tolls are added for all the tolls on the route for each payment type. If a payment type cannot be using on all the toll points on the route, the toll cost is returned as false. Else, the sum of tolls for the payment type is returned.&lt;/p&gt;&lt;p&gt;The tolls are returned for the following payment types:&lt;/p&gt;&lt;ul&gt; &lt;li&gt;Cash&lt;/li&gt;&lt;li&gt;Transponder&lt;/li&gt;&lt;li&gt;License Plate&lt;/li&gt;&lt;li&gt;Credit card&lt;/li&gt;&lt;li&gt;Prepaid pass&lt;/li&gt;&lt;/ul&gt;
    /// </summary>
    [DataContract]
    public partial class Cost : IEquatable<Cost>
    { 
        /// <summary>
        /// Gets or Sets Cash
        /// </summary>
        [DataMember(Name="cash")]
        public decimal? Cash { get; set; }

        /// <summary>
        /// Gets or Sets CreditCard
        /// </summary>
        [DataMember(Name="creditCard")]
        public decimal? CreditCard { get; set; }

        /// <summary>
        /// Gets or Sets Fuel
        /// </summary>
        [DataMember(Name="fuel")]
        public decimal? Fuel { get; set; }

        /// <summary>
        /// Gets or Sets LicensePlate
        /// </summary>
        [DataMember(Name="licensePlate")]
        public decimal? LicensePlate { get; set; }

        /// <summary>
        /// Gets or Sets OtherCost
        /// </summary>
        [DataMember(Name="otherCost")]
        public decimal? OtherCost { get; set; }

        /// <summary>
        /// Gets or Sets PrepaidCard
        /// </summary>
        [DataMember(Name="prepaidCard")]
        public decimal? PrepaidCard { get; set; }

        /// <summary>
        /// Gets or Sets Tag
        /// </summary>
        [DataMember(Name="tag")]
        public decimal? Tag { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Cost {\n");
            sb.Append("  Cash: ").Append(Cash).Append("\n");
            sb.Append("  CreditCard: ").Append(CreditCard).Append("\n");
            sb.Append("  Fuel: ").Append(Fuel).Append("\n");
            sb.Append("  LicensePlate: ").Append(LicensePlate).Append("\n");
            sb.Append("  OtherCost: ").Append(OtherCost).Append("\n");
            sb.Append("  PrepaidCard: ").Append(PrepaidCard).Append("\n");
            sb.Append("  Tag: ").Append(Tag).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            return obj.GetType() == GetType() && Equals((Cost)obj);
        }

        /// <summary>
        /// Returns true if Cost instances are equal
        /// </summary>
        /// <param name="other">Instance of Cost to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Cost other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    Cash == other.Cash ||
                    Cash != null &&
                    Cash.Equals(other.Cash)
                ) && 
                (
                    CreditCard == other.CreditCard ||
                    CreditCard != null &&
                    CreditCard.Equals(other.CreditCard)
                ) && 
                (
                    Fuel == other.Fuel ||
                    Fuel != null &&
                    Fuel.Equals(other.Fuel)
                ) && 
                (
                    LicensePlate == other.LicensePlate ||
                    LicensePlate != null &&
                    LicensePlate.Equals(other.LicensePlate)
                ) && 
                (
                    OtherCost == other.OtherCost ||
                    OtherCost != null &&
                    OtherCost.Equals(other.OtherCost)
                ) && 
                (
                    PrepaidCard == other.PrepaidCard ||
                    PrepaidCard != null &&
                    PrepaidCard.Equals(other.PrepaidCard)
                ) && 
                (
                    Tag == other.Tag ||
                    Tag != null &&
                    Tag.Equals(other.Tag)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                var hashCode = 41;
                // Suitable nullity checks etc, of course :)
                    if (Cash != null)
                    hashCode = hashCode * 59 + Cash.GetHashCode();
                    if (CreditCard != null)
                    hashCode = hashCode * 59 + CreditCard.GetHashCode();
                    if (Fuel != null)
                    hashCode = hashCode * 59 + Fuel.GetHashCode();
                    if (LicensePlate != null)
                    hashCode = hashCode * 59 + LicensePlate.GetHashCode();
                    if (OtherCost != null)
                    hashCode = hashCode * 59 + OtherCost.GetHashCode();
                    if (PrepaidCard != null)
                    hashCode = hashCode * 59 + PrepaidCard.GetHashCode();
                    if (Tag != null)
                    hashCode = hashCode * 59 + Tag.GetHashCode();
                return hashCode;
            }
        }

        #region Operators
        #pragma warning disable 1591

        public static bool operator ==(Cost left, Cost right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(Cost left, Cost right)
        {
            return !Equals(left, right);
        }

        #pragma warning restore 1591
        #endregion Operators
    }
}
