/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{ 
    /// <summary>
    /// &lt;p&gt;You need to specify parameters in &lt;code&gt;driver&lt;/code&gt; object to estimate driver wages. You can also specify your &lt;a href&#x3D;\&quot;https://en.wikipedia.org/wiki/Value_of_time\&quot;&gt;value of time&lt;/a&gt;. For example, if you are willing to spend $2.00 to save 15 minutes (but not a penny more) for a particular trip, your value of time is $2.00* (60/15) &#x3D; $8.00 per hour.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class Driver : IEquatable<Driver>
    { 
        /// <summary>
        /// How is the driver time is rounded (to 30 minutes, an hour, etc.)?
        /// </summary>
        /// <value>How is the driver time is rounded (to 30 minutes, an hour, etc.)?</value>
        [DataMember(Name="rounding")]
        public decimal? Rounding { get; set; }

        /// <summary>
        /// If driver wages are specified, do not add value of time. If value of time is specified, it is assumed you are the driver and not being paid for the time. Driver wage calculations will not be returned.
        /// </summary>
        /// <value>If driver wages are specified, do not add value of time. If value of time is specified, it is assumed you are the driver and not being paid for the time. Driver wage calculations will not be returned.</value>
        [DataMember(Name="valueOfTime")]
        public decimal? ValueOfTime { get; set; }

        /// <summary>
        /// Driver wage per hour
        /// </summary>
        /// <value>Driver wage per hour</value>
        [DataMember(Name="wage")]
        public decimal? Wage { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Driver {\n");
            sb.Append("  Rounding: ").Append(Rounding).Append("\n");
            sb.Append("  ValueOfTime: ").Append(ValueOfTime).Append("\n");
            sb.Append("  Wage: ").Append(Wage).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            return obj.GetType() == GetType() && Equals((Driver)obj);
        }

        /// <summary>
        /// Returns true if Driver instances are equal
        /// </summary>
        /// <param name="other">Instance of Driver to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Driver other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    Rounding == other.Rounding ||
                    Rounding != null &&
                    Rounding.Equals(other.Rounding)
                ) && 
                (
                    ValueOfTime == other.ValueOfTime ||
                    ValueOfTime != null &&
                    ValueOfTime.Equals(other.ValueOfTime)
                ) && 
                (
                    Wage == other.Wage ||
                    Wage != null &&
                    Wage.Equals(other.Wage)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                var hashCode = 41;
                // Suitable nullity checks etc, of course :)
                    if (Rounding != null)
                    hashCode = hashCode * 59 + Rounding.GetHashCode();
                    if (ValueOfTime != null)
                    hashCode = hashCode * 59 + ValueOfTime.GetHashCode();
                    if (Wage != null)
                    hashCode = hashCode * 59 + Wage.GetHashCode();
                return hashCode;
            }
        }

        #region Operators
        #pragma warning disable 1591

        public static bool operator ==(Driver left, Driver right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(Driver left, Driver right)
        {
            return !Equals(left, right);
        }

        #pragma warning restore 1591
        #endregion Operators
    }
}
