/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{ 
    /// <summary>
    /// If you want an accurate estimate of fuel expenses, you will need to specify parameters specific to fuel price and fuel efficiency as fuelEfficiency object.
    /// </summary>
    [DataContract]
    public partial class FuelEfficiency : IEquatable<FuelEfficiency>
    { 
        /// <summary>
        /// Gets or Sets City
        /// </summary>
        [DataMember(Name="city")]
        public decimal? City { get; set; }

        /// <summary>
        /// Gets or Sets Hwy
        /// </summary>
        [DataMember(Name="hwy")]
        public decimal? Hwy { get; set; }

        /// <summary>
        /// Gets or Sets Units
        /// </summary>
        [JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
        public enum UnitsEnum
        {
            
            /// <summary>
            /// Enum MpgEnum for mpg
            /// </summary>
            [EnumMember(Value = "mpg")]
            MpgEnum = 1,
            
            /// <summary>
            /// Enum KmplEnum for kmpl
            /// </summary>
            [EnumMember(Value = "kmpl")]
            KmplEnum = 2,
            
            /// <summary>
            /// Enum L100Enum for l100
            /// </summary>
            [EnumMember(Value = "l100")]
            L100Enum = 3
        }

        /// <summary>
        /// Gets or Sets Units
        /// </summary>
        [DataMember(Name="units")]
        public UnitsEnum? Units { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class FuelEfficiency {\n");
            sb.Append("  City: ").Append(City).Append("\n");
            sb.Append("  Hwy: ").Append(Hwy).Append("\n");
            sb.Append("  Units: ").Append(Units).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            return obj.GetType() == GetType() && Equals((FuelEfficiency)obj);
        }

        /// <summary>
        /// Returns true if FuelEfficiency instances are equal
        /// </summary>
        /// <param name="other">Instance of FuelEfficiency to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(FuelEfficiency other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    City == other.City ||
                    City != null &&
                    City.Equals(other.City)
                ) && 
                (
                    Hwy == other.Hwy ||
                    Hwy != null &&
                    Hwy.Equals(other.Hwy)
                ) && 
                (
                    Units == other.Units ||
                    Units != null &&
                    Units.Equals(other.Units)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                var hashCode = 41;
                // Suitable nullity checks etc, of course :)
                    if (City != null)
                    hashCode = hashCode * 59 + City.GetHashCode();
                    if (Hwy != null)
                    hashCode = hashCode * 59 + Hwy.GetHashCode();
                    if (Units != null)
                    hashCode = hashCode * 59 + Units.GetHashCode();
                return hashCode;
            }
        }

        #region Operators
        #pragma warning disable 1591

        public static bool operator ==(FuelEfficiency left, FuelEfficiency right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(FuelEfficiency left, FuelEfficiency right)
        {
            return !Equals(left, right);
        }

        #pragma warning restore 1591
        #endregion Operators
    }
}
