/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{ 
    /// <summary>
    /// 
    /// </summary>
    [DataContract]
    public partial class GmapResponseSummary : IEquatable<GmapResponseSummary>
    { 
        /// <summary>
        /// Gets or Sets DepartureTime
        /// </summary>
        [DataMember(Name="departure_time")]
        public decimal? DepartureTime { get; set; }

        /// <summary>
        /// City fuel efficiency and highway fuel efficiency from request or the default values. Returns fuel efficiency units
        /// </summary>
        /// <value>City fuel efficiency and highway fuel efficiency from request or the default values. Returns fuel efficiency units</value>
        [DataMember(Name="fuelEfficiency")]
        public Object FuelEfficiency { get; set; }

        /// <summary>
        /// Gets or Sets FuelPrice
        /// </summary>
        [DataMember(Name="fuelPrice")]
        public GmapResponseSummaryFuelPrice FuelPrice { get; set; }

        /// <summary>
        /// Gets or Sets Rates
        /// </summary>
        [DataMember(Name="rates")]
        public Rates Rates { get; set; }

        /// <summary>
        /// Gets or Sets Route
        /// </summary>
        [DataMember(Name="route")]
        public List<Route> Route { get; set; }

        /// <summary>
        /// Gets or Sets Share
        /// </summary>
        [DataMember(Name="share")]
        public Object Share { get; set; }

        /// <summary>
        /// Gets or Sets VehicleType
        /// </summary>
        [DataMember(Name="vehicleType")]
        public Object VehicleType { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class GmapResponseSummary {\n");
            sb.Append("  DepartureTime: ").Append(DepartureTime).Append("\n");
            sb.Append("  FuelEfficiency: ").Append(FuelEfficiency).Append("\n");
            sb.Append("  FuelPrice: ").Append(FuelPrice).Append("\n");
            sb.Append("  Rates: ").Append(Rates).Append("\n");
            sb.Append("  Route: ").Append(Route).Append("\n");
            sb.Append("  Share: ").Append(Share).Append("\n");
            sb.Append("  VehicleType: ").Append(VehicleType).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            return obj.GetType() == GetType() && Equals((GmapResponseSummary)obj);
        }

        /// <summary>
        /// Returns true if GmapResponseSummary instances are equal
        /// </summary>
        /// <param name="other">Instance of GmapResponseSummary to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(GmapResponseSummary other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    DepartureTime == other.DepartureTime ||
                    DepartureTime != null &&
                    DepartureTime.Equals(other.DepartureTime)
                ) && 
                (
                    FuelEfficiency == other.FuelEfficiency ||
                    FuelEfficiency != null &&
                    FuelEfficiency.Equals(other.FuelEfficiency)
                ) && 
                (
                    FuelPrice == other.FuelPrice ||
                    FuelPrice != null &&
                    FuelPrice.Equals(other.FuelPrice)
                ) && 
                (
                    Rates == other.Rates ||
                    Rates != null &&
                    Rates.Equals(other.Rates)
                ) && 
                (
                    Route == other.Route ||
                    Route != null &&
                    Route.SequenceEqual(other.Route)
                ) && 
                (
                    Share == other.Share ||
                    Share != null &&
                    Share.Equals(other.Share)
                ) && 
                (
                    VehicleType == other.VehicleType ||
                    VehicleType != null &&
                    VehicleType.Equals(other.VehicleType)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                var hashCode = 41;
                // Suitable nullity checks etc, of course :)
                    if (DepartureTime != null)
                    hashCode = hashCode * 59 + DepartureTime.GetHashCode();
                    if (FuelEfficiency != null)
                    hashCode = hashCode * 59 + FuelEfficiency.GetHashCode();
                    if (FuelPrice != null)
                    hashCode = hashCode * 59 + FuelPrice.GetHashCode();
                    if (Rates != null)
                    hashCode = hashCode * 59 + Rates.GetHashCode();
                    if (Route != null)
                    hashCode = hashCode * 59 + Route.GetHashCode();
                    if (Share != null)
                    hashCode = hashCode * 59 + Share.GetHashCode();
                    if (VehicleType != null)
                    hashCode = hashCode * 59 + VehicleType.GetHashCode();
                return hashCode;
            }
        }

        #region Operators
        #pragma warning disable 1591

        public static bool operator ==(GmapResponseSummary left, GmapResponseSummary right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(GmapResponseSummary left, GmapResponseSummary right)
        {
            return !Equals(left, right);
        }

        #pragma warning restore 1591
        #endregion Operators
    }
}
