/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{ 
    /// <summary>
    /// 
    /// </summary>
    [DataContract]
    public partial class GmapRouteResponse : IEquatable<GmapRouteResponse>
    { 
        /// <summary>
        /// Gets or Sets Costs
        /// </summary>
        [DataMember(Name="costs")]
        public Cost Costs { get; set; }

        /// <summary>
        /// Gets or Sets Directions
        /// </summary>
        [DataMember(Name="directions")]
        public List<Direction> Directions { get; set; }

        /// <summary>
        /// Gets or Sets HerePath
        /// </summary>
        [DataMember(Name="herePath")]
        public List<decimal?> HerePath { get; set; }

        /// <summary>
        /// Gets or Sets Hos
        /// </summary>
        [DataMember(Name="hos")]
        public HosResponse Hos { get; set; }

        /// <summary>
        /// Gets or Sets Summary
        /// </summary>
        [DataMember(Name="summary")]
        public GmapRouteResponseSummary Summary { get; set; }

        /// <summary>
        /// Gets or Sets Tolls
        /// </summary>
        [DataMember(Name="tolls")]
        public List<Toll> Tolls { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class GmapRouteResponse {\n");
            sb.Append("  Costs: ").Append(Costs).Append("\n");
            sb.Append("  Directions: ").Append(Directions).Append("\n");
            sb.Append("  HerePath: ").Append(HerePath).Append("\n");
            sb.Append("  Hos: ").Append(Hos).Append("\n");
            sb.Append("  Summary: ").Append(Summary).Append("\n");
            sb.Append("  Tolls: ").Append(Tolls).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            return obj.GetType() == GetType() && Equals((GmapRouteResponse)obj);
        }

        /// <summary>
        /// Returns true if GmapRouteResponse instances are equal
        /// </summary>
        /// <param name="other">Instance of GmapRouteResponse to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(GmapRouteResponse other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    Costs == other.Costs ||
                    Costs != null &&
                    Costs.Equals(other.Costs)
                ) && 
                (
                    Directions == other.Directions ||
                    Directions != null &&
                    Directions.SequenceEqual(other.Directions)
                ) && 
                (
                    HerePath == other.HerePath ||
                    HerePath != null &&
                    HerePath.SequenceEqual(other.HerePath)
                ) && 
                (
                    Hos == other.Hos ||
                    Hos != null &&
                    Hos.Equals(other.Hos)
                ) && 
                (
                    Summary == other.Summary ||
                    Summary != null &&
                    Summary.Equals(other.Summary)
                ) && 
                (
                    Tolls == other.Tolls ||
                    Tolls != null &&
                    Tolls.SequenceEqual(other.Tolls)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                var hashCode = 41;
                // Suitable nullity checks etc, of course :)
                    if (Costs != null)
                    hashCode = hashCode * 59 + Costs.GetHashCode();
                    if (Directions != null)
                    hashCode = hashCode * 59 + Directions.GetHashCode();
                    if (HerePath != null)
                    hashCode = hashCode * 59 + HerePath.GetHashCode();
                    if (Hos != null)
                    hashCode = hashCode * 59 + Hos.GetHashCode();
                    if (Summary != null)
                    hashCode = hashCode * 59 + Summary.GetHashCode();
                    if (Tolls != null)
                    hashCode = hashCode * 59 + Tolls.GetHashCode();
                return hashCode;
            }
        }

        #region Operators
        #pragma warning disable 1591

        public static bool operator ==(GmapRouteResponse left, GmapRouteResponse right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(GmapRouteResponse left, GmapRouteResponse right)
        {
            return !Equals(left, right);
        }

        #pragma warning restore 1591
        #endregion Operators
    }
}
