/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{ 
    /// <summary>
    /// summary including distance, time (duration), name, whether the route has tolls (hasTolls), diffs object that shows the difference between the cost between the cheapest route and current route and difference in duration between the current route and the fastest route
    /// </summary>
    [DataContract]
    public partial class GmapRouteResponseSummary : IEquatable<GmapRouteResponseSummary>
    { 
        /// <summary>
        /// Gets or Sets Diffs
        /// </summary>
        [DataMember(Name="diffs")]
        public GmapRouteResponseSummaryDiffs Diffs { get; set; }

        /// <summary>
        /// Gets or Sets Distance
        /// </summary>
        [DataMember(Name="distance")]
        public GmapRouteResponseSummaryDistance Distance { get; set; }

        /// <summary>
        /// Gets or Sets Duration
        /// </summary>
        [DataMember(Name="duration")]
        public GmapRouteResponseSummaryDuration Duration { get; set; }

        /// <summary>
        /// Gets or Sets HasTolls
        /// </summary>
        [DataMember(Name="hasTolls")]
        public bool? HasTolls { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets Note
        /// </summary>
        [DataMember(Name="note")]
        public List<string> Note { get; set; }

        /// <summary>
        /// Gets or Sets Url
        /// </summary>
        [DataMember(Name="url")]
        public string Url { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class GmapRouteResponseSummary {\n");
            sb.Append("  Diffs: ").Append(Diffs).Append("\n");
            sb.Append("  Distance: ").Append(Distance).Append("\n");
            sb.Append("  Duration: ").Append(Duration).Append("\n");
            sb.Append("  HasTolls: ").Append(HasTolls).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Note: ").Append(Note).Append("\n");
            sb.Append("  Url: ").Append(Url).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            return obj.GetType() == GetType() && Equals((GmapRouteResponseSummary)obj);
        }

        /// <summary>
        /// Returns true if GmapRouteResponseSummary instances are equal
        /// </summary>
        /// <param name="other">Instance of GmapRouteResponseSummary to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(GmapRouteResponseSummary other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    Diffs == other.Diffs ||
                    Diffs != null &&
                    Diffs.Equals(other.Diffs)
                ) && 
                (
                    Distance == other.Distance ||
                    Distance != null &&
                    Distance.Equals(other.Distance)
                ) && 
                (
                    Duration == other.Duration ||
                    Duration != null &&
                    Duration.Equals(other.Duration)
                ) && 
                (
                    HasTolls == other.HasTolls ||
                    HasTolls != null &&
                    HasTolls.Equals(other.HasTolls)
                ) && 
                (
                    Name == other.Name ||
                    Name != null &&
                    Name.Equals(other.Name)
                ) && 
                (
                    Note == other.Note ||
                    Note != null &&
                    Note.SequenceEqual(other.Note)
                ) && 
                (
                    Url == other.Url ||
                    Url != null &&
                    Url.Equals(other.Url)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                var hashCode = 41;
                // Suitable nullity checks etc, of course :)
                    if (Diffs != null)
                    hashCode = hashCode * 59 + Diffs.GetHashCode();
                    if (Distance != null)
                    hashCode = hashCode * 59 + Distance.GetHashCode();
                    if (Duration != null)
                    hashCode = hashCode * 59 + Duration.GetHashCode();
                    if (HasTolls != null)
                    hashCode = hashCode * 59 + HasTolls.GetHashCode();
                    if (Name != null)
                    hashCode = hashCode * 59 + Name.GetHashCode();
                    if (Note != null)
                    hashCode = hashCode * 59 + Note.GetHashCode();
                    if (Url != null)
                    hashCode = hashCode * 59 + Url.GetHashCode();
                return hashCode;
            }
        }

        #region Operators
        #pragma warning disable 1591

        public static bool operator ==(GmapRouteResponseSummary left, GmapRouteResponseSummary right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(GmapRouteResponseSummary left, GmapRouteResponseSummary right)
        {
            return !Equals(left, right);
        }

        #pragma warning restore 1591
        #endregion Operators
    }
}
