/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{ 
    /// <summary>
    /// 
    /// </summary>
    [DataContract]
    public partial class HereRequestBody : IEquatable<HereRequestBody>
    { 
        /// <summary>
        /// Gets or Sets DepartureTime
        /// </summary>
        [DataMember(Name="departure_time")]
        public Object DepartureTime { get; set; }

        /// <summary>
        /// Driver wage or Value of Time
        /// </summary>
        /// <value>Driver wage or Value of Time</value>
        [DataMember(Name="driver")]
        public Object Driver { get; set; }

        /// <summary>
        /// Gets or Sets From
        /// </summary>
        [Required]
        [DataMember(Name="from")]
        public Object From { get; set; }

        /// <summary>
        /// Gets or Sets FuelEfficiency
        /// </summary>
        [DataMember(Name="fuelEfficiency")]
        public Object FuelEfficiency { get; set; }

        /// <summary>
        /// Gets or Sets FuelPrice
        /// </summary>
        [DataMember(Name="fuelPrice")]
        public decimal? FuelPrice { get; set; }

        /// <summary>
        /// Gets or Sets FuelPriceCurrency
        /// </summary>
        [JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
        public enum FuelPriceCurrencyEnum
        {
            
            /// <summary>
            /// Enum USDEnum for USD
            /// </summary>
            [EnumMember(Value = "USD")]
            USDEnum = 1,
            
            /// <summary>
            /// Enum CADEnum for CAD
            /// </summary>
            [EnumMember(Value = "CAD")]
            CADEnum = 2,
            
            /// <summary>
            /// Enum MXNEnum for MXN
            /// </summary>
            [EnumMember(Value = "MXN")]
            MXNEnum = 3,
            
            /// <summary>
            /// Enum INREnum for INR
            /// </summary>
            [EnumMember(Value = "INR")]
            INREnum = 4
        }

        /// <summary>
        /// Gets or Sets FuelPriceCurrency
        /// </summary>
        [DataMember(Name="fuelPriceCurrency")]
        public FuelPriceCurrencyEnum? FuelPriceCurrency { get; set; }

        /// <summary>
        /// Gets or Sets Hos
        /// </summary>
        [DataMember(Name="hos")]
        public Object Hos { get; set; }

        /// <summary>
        /// Gets or Sets StateMileage
        /// </summary>
        [DataMember(Name="state_mileage")]
        public bool? StateMileage { get; set; }

        /// <summary>
        /// Gets or Sets To
        /// </summary>
        [Required]
        [DataMember(Name="to")]
        public Object To { get; set; }

        /// <summary>
        /// Truck routing only
        /// </summary>
        /// <value>Truck routing only</value>
        [DataMember(Name="truck")]
        public Object Truck { get; set; }

        /// <summary>
        /// Gets or Sets VehicleType
        /// </summary>
        [DataMember(Name="vehicleType")]
        public Object VehicleType { get; set; }

        /// <summary>
        /// Gets or Sets Waypoints
        /// </summary>
        [DataMember(Name="waypoints")]
        public List<Location> Waypoints { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class HereRequestBody {\n");
            sb.Append("  DepartureTime: ").Append(DepartureTime).Append("\n");
            sb.Append("  Driver: ").Append(Driver).Append("\n");
            sb.Append("  From: ").Append(From).Append("\n");
            sb.Append("  FuelEfficiency: ").Append(FuelEfficiency).Append("\n");
            sb.Append("  FuelPrice: ").Append(FuelPrice).Append("\n");
            sb.Append("  FuelPriceCurrency: ").Append(FuelPriceCurrency).Append("\n");
            sb.Append("  Hos: ").Append(Hos).Append("\n");
            sb.Append("  StateMileage: ").Append(StateMileage).Append("\n");
            sb.Append("  To: ").Append(To).Append("\n");
            sb.Append("  Truck: ").Append(Truck).Append("\n");
            sb.Append("  VehicleType: ").Append(VehicleType).Append("\n");
            sb.Append("  Waypoints: ").Append(Waypoints).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            return obj.GetType() == GetType() && Equals((HereRequestBody)obj);
        }

        /// <summary>
        /// Returns true if HereRequestBody instances are equal
        /// </summary>
        /// <param name="other">Instance of HereRequestBody to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(HereRequestBody other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    DepartureTime == other.DepartureTime ||
                    DepartureTime != null &&
                    DepartureTime.Equals(other.DepartureTime)
                ) && 
                (
                    Driver == other.Driver ||
                    Driver != null &&
                    Driver.Equals(other.Driver)
                ) && 
                (
                    From == other.From ||
                    From != null &&
                    From.Equals(other.From)
                ) && 
                (
                    FuelEfficiency == other.FuelEfficiency ||
                    FuelEfficiency != null &&
                    FuelEfficiency.Equals(other.FuelEfficiency)
                ) && 
                (
                    FuelPrice == other.FuelPrice ||
                    FuelPrice != null &&
                    FuelPrice.Equals(other.FuelPrice)
                ) && 
                (
                    FuelPriceCurrency == other.FuelPriceCurrency ||
                    FuelPriceCurrency != null &&
                    FuelPriceCurrency.Equals(other.FuelPriceCurrency)
                ) && 
                (
                    Hos == other.Hos ||
                    Hos != null &&
                    Hos.Equals(other.Hos)
                ) && 
                (
                    StateMileage == other.StateMileage ||
                    StateMileage != null &&
                    StateMileage.Equals(other.StateMileage)
                ) && 
                (
                    To == other.To ||
                    To != null &&
                    To.Equals(other.To)
                ) && 
                (
                    Truck == other.Truck ||
                    Truck != null &&
                    Truck.Equals(other.Truck)
                ) && 
                (
                    VehicleType == other.VehicleType ||
                    VehicleType != null &&
                    VehicleType.Equals(other.VehicleType)
                ) && 
                (
                    Waypoints == other.Waypoints ||
                    Waypoints != null &&
                    Waypoints.SequenceEqual(other.Waypoints)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                var hashCode = 41;
                // Suitable nullity checks etc, of course :)
                    if (DepartureTime != null)
                    hashCode = hashCode * 59 + DepartureTime.GetHashCode();
                    if (Driver != null)
                    hashCode = hashCode * 59 + Driver.GetHashCode();
                    if (From != null)
                    hashCode = hashCode * 59 + From.GetHashCode();
                    if (FuelEfficiency != null)
                    hashCode = hashCode * 59 + FuelEfficiency.GetHashCode();
                    if (FuelPrice != null)
                    hashCode = hashCode * 59 + FuelPrice.GetHashCode();
                    if (FuelPriceCurrency != null)
                    hashCode = hashCode * 59 + FuelPriceCurrency.GetHashCode();
                    if (Hos != null)
                    hashCode = hashCode * 59 + Hos.GetHashCode();
                    if (StateMileage != null)
                    hashCode = hashCode * 59 + StateMileage.GetHashCode();
                    if (To != null)
                    hashCode = hashCode * 59 + To.GetHashCode();
                    if (Truck != null)
                    hashCode = hashCode * 59 + Truck.GetHashCode();
                    if (VehicleType != null)
                    hashCode = hashCode * 59 + VehicleType.GetHashCode();
                    if (Waypoints != null)
                    hashCode = hashCode * 59 + Waypoints.GetHashCode();
                return hashCode;
            }
        }

        #region Operators
        #pragma warning disable 1591

        public static bool operator ==(HereRequestBody left, HereRequestBody right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(HereRequestBody left, HereRequestBody right)
        {
            return !Equals(left, right);
        }

        #pragma warning restore 1591
        #endregion Operators
    }
}
