/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{ 
    /// <summary>
    /// 
    /// </summary>
    [DataContract]
    public partial class HosReq : IEquatable<HosReq>
    { 
        /// <summary>
        /// Gets or Sets DrivingHoursBeforeEndOfWorkDay
        /// </summary>
        [DataMember(Name="drivingHoursBeforeEndOfWorkDay")]
        public decimal? DrivingHoursBeforeEndOfWorkDay { get; set; }

        /// <summary>
        /// Gets or Sets DutyHoursBeforeEndOfWorkDay
        /// </summary>
        [DataMember(Name="dutyHoursBeforeEndOfWorkDay")]
        public decimal? DutyHoursBeforeEndOfWorkDay { get; set; }

        /// <summary>
        /// Gets or Sets DutyHoursBeforeRestBreak
        /// </summary>
        [DataMember(Name="dutyHoursBeforeRestBreak")]
        public decimal? DutyHoursBeforeRestBreak { get; set; }

        /// <summary>
        /// Gets or Sets Rule
        /// </summary>
        [JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
        public enum RuleEnum
        {
            
            /// <summary>
            /// Enum _60Enum for 60
            /// </summary>
            [EnumMember(Value = "60")]
            _60Enum = 1,
            
            /// <summary>
            /// Enum _70Enum for 70
            /// </summary>
            [EnumMember(Value = "70")]
            _70Enum = 2
        }

        /// <summary>
        /// Gets or Sets Rule
        /// </summary>
        [DataMember(Name="rule")]
        public RuleEnum? Rule { get; set; }

        /// <summary>
        /// Gets or Sets TimeRemaining
        /// </summary>
        [DataMember(Name="timeRemaining")]
        public decimal? TimeRemaining { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class HosReq {\n");
            sb.Append("  DrivingHoursBeforeEndOfWorkDay: ").Append(DrivingHoursBeforeEndOfWorkDay).Append("\n");
            sb.Append("  DutyHoursBeforeEndOfWorkDay: ").Append(DutyHoursBeforeEndOfWorkDay).Append("\n");
            sb.Append("  DutyHoursBeforeRestBreak: ").Append(DutyHoursBeforeRestBreak).Append("\n");
            sb.Append("  Rule: ").Append(Rule).Append("\n");
            sb.Append("  TimeRemaining: ").Append(TimeRemaining).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            return obj.GetType() == GetType() && Equals((HosReq)obj);
        }

        /// <summary>
        /// Returns true if HosReq instances are equal
        /// </summary>
        /// <param name="other">Instance of HosReq to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(HosReq other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    DrivingHoursBeforeEndOfWorkDay == other.DrivingHoursBeforeEndOfWorkDay ||
                    DrivingHoursBeforeEndOfWorkDay != null &&
                    DrivingHoursBeforeEndOfWorkDay.Equals(other.DrivingHoursBeforeEndOfWorkDay)
                ) && 
                (
                    DutyHoursBeforeEndOfWorkDay == other.DutyHoursBeforeEndOfWorkDay ||
                    DutyHoursBeforeEndOfWorkDay != null &&
                    DutyHoursBeforeEndOfWorkDay.Equals(other.DutyHoursBeforeEndOfWorkDay)
                ) && 
                (
                    DutyHoursBeforeRestBreak == other.DutyHoursBeforeRestBreak ||
                    DutyHoursBeforeRestBreak != null &&
                    DutyHoursBeforeRestBreak.Equals(other.DutyHoursBeforeRestBreak)
                ) && 
                (
                    Rule == other.Rule ||
                    Rule != null &&
                    Rule.Equals(other.Rule)
                ) && 
                (
                    TimeRemaining == other.TimeRemaining ||
                    TimeRemaining != null &&
                    TimeRemaining.Equals(other.TimeRemaining)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                var hashCode = 41;
                // Suitable nullity checks etc, of course :)
                    if (DrivingHoursBeforeEndOfWorkDay != null)
                    hashCode = hashCode * 59 + DrivingHoursBeforeEndOfWorkDay.GetHashCode();
                    if (DutyHoursBeforeEndOfWorkDay != null)
                    hashCode = hashCode * 59 + DutyHoursBeforeEndOfWorkDay.GetHashCode();
                    if (DutyHoursBeforeRestBreak != null)
                    hashCode = hashCode * 59 + DutyHoursBeforeRestBreak.GetHashCode();
                    if (Rule != null)
                    hashCode = hashCode * 59 + Rule.GetHashCode();
                    if (TimeRemaining != null)
                    hashCode = hashCode * 59 + TimeRemaining.GetHashCode();
                return hashCode;
            }
        }

        #region Operators
        #pragma warning disable 1591

        public static bool operator ==(HosReq left, HosReq right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(HosReq left, HosReq right)
        {
            return !Equals(left, right);
        }

        #pragma warning restore 1591
        #endregion Operators
    }
}
