/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{ 
    /// <summary>
    /// Tolls object contains tolls for all the toll locations on the route. For each toll location
    /// </summary>
    [DataContract]
    public partial class Toll : IEquatable<Toll>
    { 
        /// <summary>
        /// Cash toll cost
        /// </summary>
        /// <value>Cash toll cost</value>
        [DataMember(Name="cashCost")]
        public decimal? CashCost { get; set; }

        /// <summary>
        /// Credit card toll cost
        /// </summary>
        /// <value>Credit card toll cost</value>
        [DataMember(Name="creditCardCost")]
        public decimal? CreditCardCost { get; set; }

        /// <summary>
        /// Currency
        /// </summary>
        /// <value>Currency</value>
        [DataMember(Name="currency")]
        public string Currency { get; set; }

        /// <summary>
        /// Tollguru toll ID. Useful for error checking
        /// </summary>
        /// <value>Tollguru toll ID. Useful for error checking</value>
        [DataMember(Name="id")]
        public decimal? Id { get; set; }

        /// <summary>
        /// Approximate latitude of the toll location
        /// </summary>
        /// <value>Approximate latitude of the toll location</value>
        [DataMember(Name="lat")]
        public decimal? Lat { get; set; }

        /// <summary>
        /// License plate (video) toll cost. For example, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/california/pay-by-plate-payment\&quot; target&#x3D;\&quot;_blank\&quot;&gt;Pay by Plate&lt;/a&gt; in California, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/texas/pay-by-mail\&quot; target&#x3D;\&quot;_blank\&quot;&gt;ZipCash and Pay by Mail&lt;/a&gt; in Texas, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/florida/video-payment\&quot; target&#x3D;\&quot;_blank\&quot;&gt;Pay by Plate&lt;/a&gt; in Florida, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/colorado/video-payment\&quot; target&#x3D;\&quot;_blank\&quot;&gt;License Plate Toll&lt;/a&gt; in Colorado, Camera Charges on ETR-407, etc.
        /// </summary>
        /// <value>License plate (video) toll cost. For example, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/california/pay-by-plate-payment\&quot; target&#x3D;\&quot;_blank\&quot;&gt;Pay by Plate&lt;/a&gt; in California, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/texas/pay-by-mail\&quot; target&#x3D;\&quot;_blank\&quot;&gt;ZipCash and Pay by Mail&lt;/a&gt; in Texas, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/florida/video-payment\&quot; target&#x3D;\&quot;_blank\&quot;&gt;Pay by Plate&lt;/a&gt; in Florida, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/colorado/video-payment\&quot; target&#x3D;\&quot;_blank\&quot;&gt;License Plate Toll&lt;/a&gt; in Colorado, Camera Charges on ETR-407, etc.</value>
        [DataMember(Name="licensePlateCost")]
        public decimal? LicensePlateCost { get; set; }

        /// <summary>
        /// Name of the primary license plate toll (video toll) collection system. Typically license Plate tolls are not discounted.
        /// </summary>
        /// <value>Name of the primary license plate toll (video toll) collection system. Typically license Plate tolls are not discounted.</value>
        [DataMember(Name="licensePlatePrimary")]
        public string LicensePlatePrimary { get; set; }

        /// <summary>
        /// Name of the secondary license plate toll (video toll) collection system
        /// </summary>
        /// <value>Name of the secondary license plate toll (video toll) collection system</value>
        [DataMember(Name="licensePlateSecondary")]
        public string LicensePlateSecondary { get; set; }

        /// <summary>
        /// Approximate longitude of the toll location
        /// </summary>
        /// <value>Approximate longitude of the toll location</value>
        [DataMember(Name="lng")]
        public decimal? Lng { get; set; }

        /// <summary>
        /// Name of the toll location
        /// </summary>
        /// <value>Name of the toll location</value>
        [DataMember(Name="name")]
        public string Name { get; set; }

        /// <summary>
        /// Prepaid card such as Nexpress, Nexus Card, etc. toll cost
        /// </summary>
        /// <value>Prepaid card such as Nexpress, Nexus Card, etc. toll cost</value>
        [DataMember(Name="prepaidCardCost")]
        public decimal? PrepaidCardCost { get; set; }

        /// <summary>
        /// Name of the toll road
        /// </summary>
        /// <value>Name of the toll road</value>
        [DataMember(Name="road")]
        public string Road { get; set; }

        /// <summary>
        /// State, province of the toll location
        /// </summary>
        /// <value>State, province of the toll location</value>
        [DataMember(Name="state")]
        public string State { get; set; }

        /// <summary>
        /// Transponder toll cost &lt;br&gt;For example, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/new-york/what-is-e-zpass\&quot; target&#x3D;\&quot;_blank\&quot;&gt;E-ZPass&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/texas/what-is-txtag-tolltag-eztag\&quot; target&#x3D;\&quot;_blank\&quot;&gt;TxTag&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/california/what-is-fastrak\&quot; target&#x3D;\&quot;_blank\&quot;&gt;FasTrak&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/florida/what-is-sunpass\&quot; target&#x3D;\&quot;_blank\&quot;&gt;SunPass&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/california/what-is-fastrak\&quot; target&#x3D;\&quot;_blank\&quot;&gt;FasTrak&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/colorado/what-is-expresstoll-go-pass\&quot; target&#x3D;\&quot;_blank\&quot;&gt;ExpressToll&lt;/a&gt;, etc.
        /// </summary>
        /// <value>Transponder toll cost &lt;br&gt;For example, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/new-york/what-is-e-zpass\&quot; target&#x3D;\&quot;_blank\&quot;&gt;E-ZPass&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/texas/what-is-txtag-tolltag-eztag\&quot; target&#x3D;\&quot;_blank\&quot;&gt;TxTag&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/california/what-is-fastrak\&quot; target&#x3D;\&quot;_blank\&quot;&gt;FasTrak&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/florida/what-is-sunpass\&quot; target&#x3D;\&quot;_blank\&quot;&gt;SunPass&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/california/what-is-fastrak\&quot; target&#x3D;\&quot;_blank\&quot;&gt;FasTrak&lt;/a&gt;, &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/colorado/what-is-expresstoll-go-pass\&quot; target&#x3D;\&quot;_blank\&quot;&gt;ExpressToll&lt;/a&gt;, etc.</value>
        [DataMember(Name="tagCost")]
        public decimal? TagCost { get; set; }

        /// <summary>
        /// A primary transponder that can be used on the facility. Typically primary transponders have discounts for each usage or based on volume.
        /// </summary>
        /// <value>A primary transponder that can be used on the facility. Typically primary transponders have discounts for each usage or based on volume.</value>
        [DataMember(Name="tagPrimary")]
        public List<string> TagPrimary { get; set; }

        /// <summary>
        /// All other transponders that can be used on the facility. Secondary transponders may not count towards discounts
        /// </summary>
        /// <value>All other transponders that can be used on the facility. Secondary transponders may not count towards discounts</value>
        [DataMember(Name="tagSecondary")]
        public List<string> TagSecondary { get; set; }

        /// <summary>
        /// Toll type: &lt;br&gt;&lt;code&gt;barrier&lt;/code&gt; (for example &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/texas/texas-toll-roads-bridges-express-lanes\&quot; target&#x3D;\&quot;_blank\&quot;&gt; toll roads in Texas &lt;/a&gt;), &lt;br&gt;&lt;code&gt;ticketSystem&lt;/code&gt; - ticket system (for example &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/oklahoma/oklahoma-turnpikes\&quot; target&#x3D;\&quot;_blank\&quot;&gt; toll roads in Oklahoma&lt;/a&gt;), &lt;br&gt;&lt;code&gt;distBased&lt;/code&gt; – distance based (for example &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/ontario/ontario-407-ETR-toll-highway-bridges-tunnels\&quot; target&#x3D;\&quot;_blank\&quot;&gt; ETR 407 in Ontario, Canada&lt;/a&gt;).
        /// </summary>
        /// <value>Toll type: &lt;br&gt;&lt;code&gt;barrier&lt;/code&gt; (for example &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/texas/texas-toll-roads-bridges-express-lanes\&quot; target&#x3D;\&quot;_blank\&quot;&gt; toll roads in Texas &lt;/a&gt;), &lt;br&gt;&lt;code&gt;ticketSystem&lt;/code&gt; - ticket system (for example &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/oklahoma/oklahoma-turnpikes\&quot; target&#x3D;\&quot;_blank\&quot;&gt; toll roads in Oklahoma&lt;/a&gt;), &lt;br&gt;&lt;code&gt;distBased&lt;/code&gt; – distance based (for example &lt;a href&#x3D;\&quot;https://tollguru.com/toll-info/ontario/ontario-407-ETR-toll-highway-bridges-tunnels\&quot; target&#x3D;\&quot;_blank\&quot;&gt; ETR 407 in Ontario, Canada&lt;/a&gt;).</value>
        [DataMember(Name="type")]
        public string Type { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Toll {\n");
            sb.Append("  CashCost: ").Append(CashCost).Append("\n");
            sb.Append("  CreditCardCost: ").Append(CreditCardCost).Append("\n");
            sb.Append("  Currency: ").Append(Currency).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Lat: ").Append(Lat).Append("\n");
            sb.Append("  LicensePlateCost: ").Append(LicensePlateCost).Append("\n");
            sb.Append("  LicensePlatePrimary: ").Append(LicensePlatePrimary).Append("\n");
            sb.Append("  LicensePlateSecondary: ").Append(LicensePlateSecondary).Append("\n");
            sb.Append("  Lng: ").Append(Lng).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  PrepaidCardCost: ").Append(PrepaidCardCost).Append("\n");
            sb.Append("  Road: ").Append(Road).Append("\n");
            sb.Append("  State: ").Append(State).Append("\n");
            sb.Append("  TagCost: ").Append(TagCost).Append("\n");
            sb.Append("  TagPrimary: ").Append(TagPrimary).Append("\n");
            sb.Append("  TagSecondary: ").Append(TagSecondary).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            return obj.GetType() == GetType() && Equals((Toll)obj);
        }

        /// <summary>
        /// Returns true if Toll instances are equal
        /// </summary>
        /// <param name="other">Instance of Toll to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Toll other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    CashCost == other.CashCost ||
                    CashCost != null &&
                    CashCost.Equals(other.CashCost)
                ) && 
                (
                    CreditCardCost == other.CreditCardCost ||
                    CreditCardCost != null &&
                    CreditCardCost.Equals(other.CreditCardCost)
                ) && 
                (
                    Currency == other.Currency ||
                    Currency != null &&
                    Currency.Equals(other.Currency)
                ) && 
                (
                    Id == other.Id ||
                    Id != null &&
                    Id.Equals(other.Id)
                ) && 
                (
                    Lat == other.Lat ||
                    Lat != null &&
                    Lat.Equals(other.Lat)
                ) && 
                (
                    LicensePlateCost == other.LicensePlateCost ||
                    LicensePlateCost != null &&
                    LicensePlateCost.Equals(other.LicensePlateCost)
                ) && 
                (
                    LicensePlatePrimary == other.LicensePlatePrimary ||
                    LicensePlatePrimary != null &&
                    LicensePlatePrimary.Equals(other.LicensePlatePrimary)
                ) && 
                (
                    LicensePlateSecondary == other.LicensePlateSecondary ||
                    LicensePlateSecondary != null &&
                    LicensePlateSecondary.Equals(other.LicensePlateSecondary)
                ) && 
                (
                    Lng == other.Lng ||
                    Lng != null &&
                    Lng.Equals(other.Lng)
                ) && 
                (
                    Name == other.Name ||
                    Name != null &&
                    Name.Equals(other.Name)
                ) && 
                (
                    PrepaidCardCost == other.PrepaidCardCost ||
                    PrepaidCardCost != null &&
                    PrepaidCardCost.Equals(other.PrepaidCardCost)
                ) && 
                (
                    Road == other.Road ||
                    Road != null &&
                    Road.Equals(other.Road)
                ) && 
                (
                    State == other.State ||
                    State != null &&
                    State.Equals(other.State)
                ) && 
                (
                    TagCost == other.TagCost ||
                    TagCost != null &&
                    TagCost.Equals(other.TagCost)
                ) && 
                (
                    TagPrimary == other.TagPrimary ||
                    TagPrimary != null &&
                    TagPrimary.SequenceEqual(other.TagPrimary)
                ) && 
                (
                    TagSecondary == other.TagSecondary ||
                    TagSecondary != null &&
                    TagSecondary.SequenceEqual(other.TagSecondary)
                ) && 
                (
                    Type == other.Type ||
                    Type != null &&
                    Type.Equals(other.Type)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                var hashCode = 41;
                // Suitable nullity checks etc, of course :)
                    if (CashCost != null)
                    hashCode = hashCode * 59 + CashCost.GetHashCode();
                    if (CreditCardCost != null)
                    hashCode = hashCode * 59 + CreditCardCost.GetHashCode();
                    if (Currency != null)
                    hashCode = hashCode * 59 + Currency.GetHashCode();
                    if (Id != null)
                    hashCode = hashCode * 59 + Id.GetHashCode();
                    if (Lat != null)
                    hashCode = hashCode * 59 + Lat.GetHashCode();
                    if (LicensePlateCost != null)
                    hashCode = hashCode * 59 + LicensePlateCost.GetHashCode();
                    if (LicensePlatePrimary != null)
                    hashCode = hashCode * 59 + LicensePlatePrimary.GetHashCode();
                    if (LicensePlateSecondary != null)
                    hashCode = hashCode * 59 + LicensePlateSecondary.GetHashCode();
                    if (Lng != null)
                    hashCode = hashCode * 59 + Lng.GetHashCode();
                    if (Name != null)
                    hashCode = hashCode * 59 + Name.GetHashCode();
                    if (PrepaidCardCost != null)
                    hashCode = hashCode * 59 + PrepaidCardCost.GetHashCode();
                    if (Road != null)
                    hashCode = hashCode * 59 + Road.GetHashCode();
                    if (State != null)
                    hashCode = hashCode * 59 + State.GetHashCode();
                    if (TagCost != null)
                    hashCode = hashCode * 59 + TagCost.GetHashCode();
                    if (TagPrimary != null)
                    hashCode = hashCode * 59 + TagPrimary.GetHashCode();
                    if (TagSecondary != null)
                    hashCode = hashCode * 59 + TagSecondary.GetHashCode();
                    if (Type != null)
                    hashCode = hashCode * 59 + Type.GetHashCode();
                return hashCode;
            }
        }

        #region Operators
        #pragma warning disable 1591

        public static bool operator ==(Toll left, Toll right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(Toll left, Toll right)
        {
            return !Equals(left, right);
        }

        #pragma warning restore 1591
        #endregion Operators
    }
}
