/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{ 
    /// <summary>
    /// 
    /// </summary>
    [DataContract]
    public partial class Truck : IEquatable<Truck>
    { 
        /// <summary>
        /// Vehicle height in feet. The provided value must be between 0 and 50. &lt;br&gt; If vehicle height is not specified, incorrect tolls may be calculated on New York Thruway and other toll roads where tolls are based on axles and weight.
        /// </summary>
        /// <value>Vehicle height in feet. The provided value must be between 0 and 50. &lt;br&gt; If vehicle height is not specified, incorrect tolls may be calculated on New York Thruway and other toll roads where tolls are based on axles and weight.</value>
        [DataMember(Name="height")]
        public decimal? Height { get; set; }

        /// <summary>
        /// Vehicle length in feet. The provided value must be between 0 and 300.
        /// </summary>
        /// <value>Vehicle length in feet. The provided value must be between 0 and 300.</value>
        [DataMember(Name="length")]
        public decimal? Length { get; set; }

        /// <summary>
        /// Vehicle weight including trailers and shipped goods, in pounds. &lt;br&gt; If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight.
        /// </summary>
        /// <value>Vehicle weight including trailers and shipped goods, in pounds. &lt;br&gt; If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight.</value>
        [DataMember(Name="limitedWeight")]
        public decimal? LimitedWeight { get; set; }

        /// <summary>
        /// List of hazardous materials in the vehicle. The names correspond to <a href=\"https://www.fmcsa.dot.gov/sites/fmcsa.dot.gov/files/docs/Nine_Classes_of_Hazardous_Materials-4-2013_508CLN.pdf\" target=\"_blank\"> HAZMAT classes 1 to 9. <br> For example, explosive is Class 1 and so on. </a>
        /// </summary>
        /// <value>List of hazardous materials in the vehicle. The names correspond to <a href=\"https://www.fmcsa.dot.gov/sites/fmcsa.dot.gov/files/docs/Nine_Classes_of_Hazardous_Materials-4-2013_508CLN.pdf\" target=\"_blank\"> HAZMAT classes 1 to 9. <br> For example, explosive is Class 1 and so on. </a></value>
        [JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
        public enum ShippedHazardousGoodsEnum
        {
            
            /// <summary>
            /// Enum ExplosiveEnum for explosive
            /// </summary>
            [EnumMember(Value = "explosive")]
            ExplosiveEnum = 1,
            
            /// <summary>
            /// Enum GasEnum for gas
            /// </summary>
            [EnumMember(Value = "gas")]
            GasEnum = 2,
            
            /// <summary>
            /// Enum FlammableEnum for flammable
            /// </summary>
            [EnumMember(Value = "flammable")]
            FlammableEnum = 3,
            
            /// <summary>
            /// Enum CombustibleEnum for combustible
            /// </summary>
            [EnumMember(Value = "combustible")]
            CombustibleEnum = 4,
            
            /// <summary>
            /// Enum OrganicEnum for organic
            /// </summary>
            [EnumMember(Value = "organic")]
            OrganicEnum = 5,
            
            /// <summary>
            /// Enum PoisonEnum for poison
            /// </summary>
            [EnumMember(Value = "poison")]
            PoisonEnum = 6,
            
            /// <summary>
            /// Enum RadioActiveEnum for radioActive
            /// </summary>
            [EnumMember(Value = "radioActive")]
            RadioActiveEnum = 7,
            
            /// <summary>
            /// Enum CorrosiveEnum for corrosive
            /// </summary>
            [EnumMember(Value = "corrosive")]
            CorrosiveEnum = 8,
            
            /// <summary>
            /// Enum MiscellaneousEnum for miscellaneous
            /// </summary>
            [EnumMember(Value = "miscellaneous")]
            MiscellaneousEnum = 9
        }

        /// <summary>
        /// List of hazardous materials in the vehicle. The names correspond to &lt;a href&#x3D;\&quot;https://www.fmcsa.dot.gov/sites/fmcsa.dot.gov/files/docs/Nine_Classes_of_Hazardous_Materials-4-2013_508CLN.pdf\&quot; target&#x3D;\&quot;_blank\&quot;&gt; HAZMAT classes 1 to 9. &lt;br&gt; For example, explosive is Class 1 and so on. &lt;/a&gt;
        /// </summary>
        /// <value>List of hazardous materials in the vehicle. The names correspond to &lt;a href&#x3D;\&quot;https://www.fmcsa.dot.gov/sites/fmcsa.dot.gov/files/docs/Nine_Classes_of_Hazardous_Materials-4-2013_508CLN.pdf\&quot; target&#x3D;\&quot;_blank\&quot;&gt; HAZMAT classes 1 to 9. &lt;br&gt; For example, explosive is Class 1 and so on. &lt;/a&gt;</value>
        [DataMember(Name="shippedHazardousGoods")]
        public ShippedHazardousGoodsEnum? ShippedHazardousGoods { get; set; }

        /// <summary>
        /// Specifies number of trailers pulled by a vehicle. The provided value must be between 0 and 4.
        /// </summary>
        /// <value>Specifies number of trailers pulled by a vehicle. The provided value must be between 0 and 4.</value>
        [DataMember(Name="trailersCount")]
        public decimal? TrailersCount { get; set; }

        /// <summary>
        /// pecifies the penalty type on violated truck restrictions.<br><code>strict</code>: route will not use links with a violated truck restriction at any circumstances<br><strong>Note</strong>: Route computation will fail and return NoRouteFound if not able to avoid the links with a violated truck restriction and the penalty type is strict.<br><code>soft</code>: route will use links with a violated truck restriction if there is no alternative to avoid them<
        /// </summary>
        /// <value>pecifies the penalty type on violated truck restrictions.<br><code>strict</code>: route will not use links with a violated truck restriction at any circumstances<br><strong>Note</strong>: Route computation will fail and return NoRouteFound if not able to avoid the links with a violated truck restriction and the penalty type is strict.<br><code>soft</code>: route will use links with a violated truck restriction if there is no alternative to avoid them<</value>
        [JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
        public enum TruckRestrictionPenaltyEnum
        {
            
            /// <summary>
            /// Enum StrictEnum for strict
            /// </summary>
            [EnumMember(Value = "strict")]
            StrictEnum = 1,
            
            /// <summary>
            /// Enum SoftEnum for soft
            /// </summary>
            [EnumMember(Value = "soft")]
            SoftEnum = 2
        }

        /// <summary>
        /// pecifies the penalty type on violated truck restrictions.&lt;br&gt;&lt;code&gt;strict&lt;/code&gt;: route will not use links with a violated truck restriction at any circumstances&lt;br&gt;&lt;strong&gt;Note&lt;/strong&gt;: Route computation will fail and return NoRouteFound if not able to avoid the links with a violated truck restriction and the penalty type is strict.&lt;br&gt;&lt;code&gt;soft&lt;/code&gt;: route will use links with a violated truck restriction if there is no alternative to avoid them&lt;
        /// </summary>
        /// <value>pecifies the penalty type on violated truck restrictions.&lt;br&gt;&lt;code&gt;strict&lt;/code&gt;: route will not use links with a violated truck restriction at any circumstances&lt;br&gt;&lt;strong&gt;Note&lt;/strong&gt;: Route computation will fail and return NoRouteFound if not able to avoid the links with a violated truck restriction and the penalty type is strict.&lt;br&gt;&lt;code&gt;soft&lt;/code&gt;: route will use links with a violated truck restriction if there is no alternative to avoid them&lt;</value>
        [DataMember(Name="truckRestrictionPenalty")]
        public TruckRestrictionPenaltyEnum? TruckRestrictionPenalty { get; set; }

        /// <summary>
        /// Specifies the vehicle type<br><strong>Note</strong>: Relevant for restrictions that apply exclusively to tractors with semi-trailers (observed in North America). Such restrictions are taken into account only in case of the <code>truckType</code> set to <code>tractorTruck</code> and the trailers count greater than 0 (for example <code>truckType: \"tractorTruck\", trailersCount: 1</code>). The truck type is irrelevant in case of restrictions common for all types of trucks.
        /// </summary>
        /// <value>Specifies the vehicle type<br><strong>Note</strong>: Relevant for restrictions that apply exclusively to tractors with semi-trailers (observed in North America). Such restrictions are taken into account only in case of the <code>truckType</code> set to <code>tractorTruck</code> and the trailers count greater than 0 (for example <code>truckType: \"tractorTruck\", trailersCount: 1</code>). The truck type is irrelevant in case of restrictions common for all types of trucks.</value>
        [JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
        public enum TruckTypeEnum
        {
            
            /// <summary>
            /// Enum TruckEnum for truck
            /// </summary>
            [EnumMember(Value = "truck")]
            TruckEnum = 1,
            
            /// <summary>
            /// Enum TractorTruckEnum for tractorTruck
            /// </summary>
            [EnumMember(Value = "tractorTruck")]
            TractorTruckEnum = 2
        }

        /// <summary>
        /// Specifies the vehicle type&lt;br&gt;&lt;strong&gt;Note&lt;/strong&gt;: Relevant for restrictions that apply exclusively to tractors with semi-trailers (observed in North America). Such restrictions are taken into account only in case of the &lt;code&gt;truckType&lt;/code&gt; set to &lt;code&gt;tractorTruck&lt;/code&gt; and the trailers count greater than 0 (for example &lt;code&gt;truckType: \&quot;tractorTruck\&quot;, trailersCount: 1&lt;/code&gt;). The truck type is irrelevant in case of restrictions common for all types of trucks.
        /// </summary>
        /// <value>Specifies the vehicle type&lt;br&gt;&lt;strong&gt;Note&lt;/strong&gt;: Relevant for restrictions that apply exclusively to tractors with semi-trailers (observed in North America). Such restrictions are taken into account only in case of the &lt;code&gt;truckType&lt;/code&gt; set to &lt;code&gt;tractorTruck&lt;/code&gt; and the trailers count greater than 0 (for example &lt;code&gt;truckType: \&quot;tractorTruck\&quot;, trailersCount: 1&lt;/code&gt;). The truck type is irrelevant in case of restrictions common for all types of trucks.</value>
        [DataMember(Name="truckType")]
        public TruckTypeEnum? TruckType { get; set; }

        /// <summary>
        /// Specifies the tunnel category to restrict certain route links. The route will pass only through tunnels of a less strict category.
        /// </summary>
        /// <value>Specifies the tunnel category to restrict certain route links. The route will pass only through tunnels of a less strict category.</value>
        [JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
        public enum TunnelCategoryEnum
        {
            
            /// <summary>
            /// Enum BEnum for B
            /// </summary>
            [EnumMember(Value = "B")]
            BEnum = 1,
            
            /// <summary>
            /// Enum CEnum for C
            /// </summary>
            [EnumMember(Value = "C")]
            CEnum = 2,
            
            /// <summary>
            /// Enum DEnum for D
            /// </summary>
            [EnumMember(Value = "D")]
            DEnum = 3,
            
            /// <summary>
            /// Enum EEnum for E
            /// </summary>
            [EnumMember(Value = "E")]
            EEnum = 4
        }

        /// <summary>
        /// Specifies the tunnel category to restrict certain route links. The route will pass only through tunnels of a less strict category.
        /// </summary>
        /// <value>Specifies the tunnel category to restrict certain route links. The route will pass only through tunnels of a less strict category.</value>
        [DataMember(Name="tunnelCategory")]
        public TunnelCategoryEnum? TunnelCategory { get; set; }

        /// <summary>
        /// Vehicle weight per axle in pounds. &lt;br&gt; If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight.
        /// </summary>
        /// <value>Vehicle weight per axle in pounds. &lt;br&gt; If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight.</value>
        [DataMember(Name="weightPerAxle")]
        public decimal? WeightPerAxle { get; set; }

        /// <summary>
        /// Vehicle width in feet. The provided value must be between 0 and 50.
        /// </summary>
        /// <value>Vehicle width in feet. The provided value must be between 0 and 50.</value>
        [DataMember(Name="width")]
        public decimal? Width { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Truck {\n");
            sb.Append("  Height: ").Append(Height).Append("\n");
            sb.Append("  Length: ").Append(Length).Append("\n");
            sb.Append("  LimitedWeight: ").Append(LimitedWeight).Append("\n");
            sb.Append("  ShippedHazardousGoods: ").Append(ShippedHazardousGoods).Append("\n");
            sb.Append("  TrailersCount: ").Append(TrailersCount).Append("\n");
            sb.Append("  TruckRestrictionPenalty: ").Append(TruckRestrictionPenalty).Append("\n");
            sb.Append("  TruckType: ").Append(TruckType).Append("\n");
            sb.Append("  TunnelCategory: ").Append(TunnelCategory).Append("\n");
            sb.Append("  WeightPerAxle: ").Append(WeightPerAxle).Append("\n");
            sb.Append("  Width: ").Append(Width).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            return obj.GetType() == GetType() && Equals((Truck)obj);
        }

        /// <summary>
        /// Returns true if Truck instances are equal
        /// </summary>
        /// <param name="other">Instance of Truck to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Truck other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    Height == other.Height ||
                    Height != null &&
                    Height.Equals(other.Height)
                ) && 
                (
                    Length == other.Length ||
                    Length != null &&
                    Length.Equals(other.Length)
                ) && 
                (
                    LimitedWeight == other.LimitedWeight ||
                    LimitedWeight != null &&
                    LimitedWeight.Equals(other.LimitedWeight)
                ) && 
                (
                    ShippedHazardousGoods == other.ShippedHazardousGoods ||
                    ShippedHazardousGoods != null &&
                    ShippedHazardousGoods.Equals(other.ShippedHazardousGoods)
                ) && 
                (
                    TrailersCount == other.TrailersCount ||
                    TrailersCount != null &&
                    TrailersCount.Equals(other.TrailersCount)
                ) && 
                (
                    TruckRestrictionPenalty == other.TruckRestrictionPenalty ||
                    TruckRestrictionPenalty != null &&
                    TruckRestrictionPenalty.Equals(other.TruckRestrictionPenalty)
                ) && 
                (
                    TruckType == other.TruckType ||
                    TruckType != null &&
                    TruckType.Equals(other.TruckType)
                ) && 
                (
                    TunnelCategory == other.TunnelCategory ||
                    TunnelCategory != null &&
                    TunnelCategory.Equals(other.TunnelCategory)
                ) && 
                (
                    WeightPerAxle == other.WeightPerAxle ||
                    WeightPerAxle != null &&
                    WeightPerAxle.Equals(other.WeightPerAxle)
                ) && 
                (
                    Width == other.Width ||
                    Width != null &&
                    Width.Equals(other.Width)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                var hashCode = 41;
                // Suitable nullity checks etc, of course :)
                    if (Height != null)
                    hashCode = hashCode * 59 + Height.GetHashCode();
                    if (Length != null)
                    hashCode = hashCode * 59 + Length.GetHashCode();
                    if (LimitedWeight != null)
                    hashCode = hashCode * 59 + LimitedWeight.GetHashCode();
                    if (ShippedHazardousGoods != null)
                    hashCode = hashCode * 59 + ShippedHazardousGoods.GetHashCode();
                    if (TrailersCount != null)
                    hashCode = hashCode * 59 + TrailersCount.GetHashCode();
                    if (TruckRestrictionPenalty != null)
                    hashCode = hashCode * 59 + TruckRestrictionPenalty.GetHashCode();
                    if (TruckType != null)
                    hashCode = hashCode * 59 + TruckType.GetHashCode();
                    if (TunnelCategory != null)
                    hashCode = hashCode * 59 + TunnelCategory.GetHashCode();
                    if (WeightPerAxle != null)
                    hashCode = hashCode * 59 + WeightPerAxle.GetHashCode();
                    if (Width != null)
                    hashCode = hashCode * 59 + Width.GetHashCode();
                return hashCode;
            }
        }

        #region Operators
        #pragma warning disable 1591

        public static bool operator ==(Truck left, Truck right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(Truck left, Truck right)
        {
            return !Equals(left, right);
        }

        #pragma warning restore 1591
        #endregion Operators
    }
}
