/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * OpenAPI spec version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc;
using Swashbuckle.AspNetCore.Annotations;
using Swashbuckle.AspNetCore.SwaggerGen;
using Newtonsoft.Json;
using System.ComponentModel.DataAnnotations;
using IO.Swagger.Attributes;
using IO.Swagger.Security;
using Microsoft.AspNetCore.Authorization;
using IO.Swagger.Models;

namespace IO.Swagger.Controllers
{ 
    /// <summary>
    /// 
    /// </summary>
    [ApiController]
    public class OriginAndDestinationPairApiController : ControllerBase
    { 
        /// <summary>
        /// Google Maps Routes
        /// </summary>
        /// <remarks>HTTP Request for cars, SUVs, pick-ups, motorcycles</remarks>
        /// <param name="body"></param>
        /// <response code="200">200 response</response>
        [HttpPost]
        [Route("//gmaps")]
        [Authorize(AuthenticationSchemes = ApiKeyAuthenticationHandler.SchemeName)]
        [ValidateModelState]
        [SwaggerOperation("GmapsPost")]
        [SwaggerResponse(statusCode: 200, type: typeof(GmapResponse), description: "200 response")]
        public virtual IActionResult GmapsPost([FromBody]GmapRequestBody body)
        { 
            //TODO: Uncomment the next line to return response 200 or use other options such as return this.NotFound(), return this.BadRequest(..), ...
            // return StatusCode(200, default(GmapResponse));

            string exampleJson = null;
            exampleJson = "{\n  \"summary\" : {\n    \"fuelEfficiency\" : {\n      \"city\" : 24,\n      \"hwy\" : 30,\n      \"units\" : \"mpg\"\n    },\n    \"route\" : [ {\n      \"address\" : \"Main St, Dallas, TX 75201, United States\",\n      \"location\" : {\n        \"lat\" : 32.78165,\n        \"lng\" : -96.79448\n      }\n    }, {\n      \"address\" : \"Plano, TX, United States\",\n      \"location\" : {\n        \"lat\" : 33.02079,\n        \"lng\" : -96.69925\n      }\n    }, {\n      \"address\" : \"Allen, TX, United States\",\n      \"location\" : {\n        \"lat\" : 33.10144,\n        \"lng\" : -96.67449\n      }\n    }, {\n      \"address\" : \"Addison, TX, United States\",\n      \"location\" : {\n        \"lat\" : 32.95398,\n        \"lng\" : -96.81769\n      }\n    } ],\n    \"rates\" : {\n      \"CAD\" : 1.342395,\n      \"INR\" : 75.49545,\n      \"MXN\" : 21.748097,\n      \"USD\" : 1\n    },\n    \"fuelPrice\" : \"{\\"currency\\":\\"USD\\",\\"value\\":2.79}\",\n    \"share\" : \"{}\",\n    \"departure_time\" : 1.551541566E9,\n    \"vehicleType\" : \"2AxlesAuto\"\n  },\n  \"routes\" : [ {\n    \"summary\" : {\n      \"duration\" : \"{\\"metric\\":\\"72.7 km\\",\\"text\\":\\"45.2 mi\\",\\"value\\":72731}\",\n      \"note\" : [ ],\n      \"distance\" : \"{\\"text\\":\\"1 h 2 min\\",\\"value\\":3742}\",\n      \"name\" : \"US-75\",\n      \"hasTolls\" : true,\n      \"diffs\" : \"{\\"cheapest\\":\\"2.63,\\",\\"fastest\\":0}\",\n      \"url\" : \"https://www.google.com/maps/?saddr=32.781643,-96.7944781&daddr=32.7839434,-96.7915463+to:32.789104,-96.7916107+to:33.0207898,-96.6992516+to:33.1014399,-96.6744947+to:33.007983,-96.7079687+to:32.9539847,-96.81769&via=1,2,3,4,5\"\n    },\n    \"costs\" : {\n      \"cash\" : false,\n      \"creditCard\" : false,\n      \"fuel\" : 4.31,\n      \"licensePlate\" : 3.69,\n      \"otherCost\" : 10,\n      \"prepaidCard\" : 2.46,\n      \"tag\" : 2.46\n    },\n    \"directions\" : [ {\n      \"distance\" : 29,\n      \"duration\" : 50,\n      \"html_instructions\" : \"Head toward <span class=\\"toward_street\\">S Lamar St</span> on <span class=\\"street\\">Main St</span>. <span class=\\"distance-description\\">Go for <span class=\\"length\\">95 ft</span>.</span>\",\n      \"maneuver\" : \"forward\",\n      \"note\" : [ ],\n      \"position\" : {\n        \"latitude\" : 32.7795011,\n        \"longitude\" : -96.8045704\n      }\n    } ],\n    \"herePath\" : [ 32.7795011, -96.8045704, 32.7795553, -96.8042707, 32.7810788, \"-96.8046463,\", \"...\" ],\n    \"hos\" : {\n      \"summary\" : \"{\\"rulesParam\\":{\\"drivingHoursBeforeEndOfWorkDay\\":11,\\"dutyHoursBeforeEndOfWorkDay\\":11,\\"dutyHoursBeforeRestBreak\\":7.5,\\"rule\\":60,\\"timeRemaining\\":60},\\"total_break_duration\\":{\\"text\\":null,\\"value\\":0},\\"total_distance\\":{\\"metric\\":73,\\"text\\":46,\\"value\\":73302},\\"total_drive_duration\\":{\\"text\\":\\"1 h 23 m\\",\\"value\\":5004},\\"total_duration\\":{\\"text\\":\\"1 h 23 m\\",\\"value\\":5004}}\",\n      \"data\" : [ {\n        \"instruction\" : \"Start from Plano, TX USA\"\n      }, {\n        \"distance\" : {\n          \"metric\" : 43,\n          \"text\" : 26,\n          \"value\" : 42514\n        },\n        \"duration\" : {\n          \"text\" : \"53 m\",\n          \"value\" : 3216\n        },\n        \"instruction\" : \"Drive\"\n      }, {\n        \"duration\" : {\n          \"text\" : \"30 m\",\n          \"value\" : 1800\n        },\n        \"instruction\" : \"Break\"\n      } ],\n      \"break_points\" : [ [ 33.02079, -96.69925 ] ],\n      \"stops\" : [ {\n        \"additionalServices\" : \"\",\n        \"amenities\" : \"Parking, Truck\",\n        \"businessesName\" : \"Rodeway Inn\",\n        \"city\" : \"Sandusky\",\n        \"contactName\" : \"\",\n        \"fax\" : \"(419) 626-4118\",\n        \"fuelLanes\" : -1,\n        \"highway\" : \"\",\n        \"latitude\" : 41.4465332,\n        \"longitude\" : -82.69683075,\n        \"parkingSpots\" : \"\",\n        \"paymentMethods\" : \"\",\n        \"phone1\" : \"(419) 626-6852\",\n        \"phone2\" : \"\",\n        \"phone3\" : \"\",\n        \"postalCode\" : \"\",\n        \"restIndex\" : \"1\",\n        \"showers\" : -1,\n        \"state\" : \"OH\",\n        \"stopId\" : 5254,\n        \"streetAddress\" : \"1021 Cleveland Rd.\",\n        \"truckServiceBays\" : -1,\n        \"type\" : \"motels\",\n        \"webAddress\" : \"\"\n      } ]\n    },\n    \"tolls\" : [ {\n      \"cashCost\" : false,\n      \"creditCardCost\" : false,\n      \"currency\" : \"USD\",\n      \"discountCarDetails\" : false,\n      \"discountCarType\" : false,\n      \"discountTruckDetails\" : false,\n      \"discountTrucks\" : false,\n      \"height\" : \"No\",\n      \"id\" : 131030,\n      \"lat\" : 33.00225,\n      \"licensePlateCost\" : 2.01,\n      \"licensePlatePrimary\" : \"ZipCash\",\n      \"licensePlateSecondary\" : false,\n      \"lng\" : -96.77585,\n      \"name\" : \"Coit Main Lane Gantry (MLP7)\",\n      \"prepaidCardCost\" : 1.34,\n      \"road\" : \"President George Bush Tpke\",\n      \"state\" : \"Texas\",\n      \"tagCost\" : 1.34,\n      \"tagPriCost\" : 1.34,\n      \"tagPrimary\" : [ \"TxTAG\", \"TollTag\", \"EZ TAG\", \"K-Tag\" ],\n      \"tagSecCost\" : false,\n      \"tagSecondary\" : [ ],\n      \"type\" : \"barrier\"\n    }, {\n      \"cashCost\" : false,\n      \"creditCardCost\" : false,\n      \"currency\" : \"USD\",\n      \"discountCarDetails\" : false,\n      \"discountCarType\" : false,\n      \"discountTruckDetails\" : false,\n      \"discountTrucks\" : false,\n      \"height\" : \"No\",\n      \"id\" : 131030,\n      \"lat\" : 33.00225,\n      \"licensePlateCost\" : 2.01,\n      \"licensePlatePrimary\" : \"ZipCash\",\n      \"licensePlateSecondary\" : false,\n      \"lng\" : -96.77585,\n      \"name\" : \"Coit Main Lane Gantry (MLP7)\",\n      \"prepaidCardCost\" : 1.34,\n      \"road\" : \"President George Bush Tpke\",\n      \"state\" : \"Texas\",\n      \"tagCost\" : 1.34,\n      \"tagPriCost\" : 1.34,\n      \"tagPrimary\" : [ \"TxTAG\", \"TollTag\", \"EZ TAG\", \"K-Tag\" ],\n      \"tagSecCost\" : false,\n      \"tagSecondary\" : [ ],\n      \"type\" : \"barrier\"\n    } ]\n  }, {\n    \"summary\" : {\n      \"duration\" : \"{\\"metric\\":\\"72.7 km\\",\\"text\\":\\"45.2 mi\\",\\"value\\":72731}\",\n      \"note\" : [ ],\n      \"distance\" : \"{\\"text\\":\\"1 h 2 min\\",\\"value\\":3742}\",\n      \"name\" : \"US-75\",\n      \"hasTolls\" : true,\n      \"diffs\" : \"{\\"cheapest\\":\\"2.63,\\",\\"fastest\\":0}\",\n      \"url\" : \"https://www.google.com/maps/?saddr=32.781643,-96.7944781&daddr=32.7839434,-96.7915463+to:32.789104,-96.7916107+to:33.0207898,-96.6992516+to:33.1014399,-96.6744947+to:33.007983,-96.7079687+to:32.9539847,-96.81769&via=1,2,3,4,5\"\n    },\n    \"costs\" : {\n      \"cash\" : false,\n      \"creditCard\" : false,\n      \"fuel\" : 4.31,\n      \"licensePlate\" : 3.69,\n      \"otherCost\" : 10,\n      \"prepaidCard\" : 2.46,\n      \"tag\" : 2.46\n    },\n    \"directions\" : [ {\n      \"distance\" : 29,\n      \"duration\" : 50,\n      \"html_instructions\" : \"Head toward <span class=\\"toward_street\\">S Lamar St</span> on <span class=\\"street\\">Main St</span>. <span class=\\"distance-description\\">Go for <span class=\\"length\\">95 ft</span>.</span>\",\n      \"maneuver\" : \"forward\",\n      \"note\" : [ ],\n      \"position\" : {\n        \"latitude\" : 32.7795011,\n        \"longitude\" : -96.8045704\n      }\n    } ],\n    \"herePath\" : [ 32.7795011, -96.8045704, 32.7795553, -96.8042707, 32.7810788, \"-96.8046463,\", \"...\" ],\n    \"hos\" : {\n      \"summary\" : \"{\\"rulesParam\\":{\\"drivingHoursBeforeEndOfWorkDay\\":11,\\"dutyHoursBeforeEndOfWorkDay\\":11,\\"dutyHoursBeforeRestBreak\\":7.5,\\"rule\\":60,\\"timeRemaining\\":60},\\"total_break_duration\\":{\\"text\\":null,\\"value\\":0},\\"total_distance\\":{\\"metric\\":73,\\"text\\":46,\\"value\\":73302},\\"total_drive_duration\\":{\\"text\\":\\"1 h 23 m\\",\\"value\\":5004},\\"total_duration\\":{\\"text\\":\\"1 h 23 m\\",\\"value\\":5004}}\",\n      \"data\" : [ {\n        \"instruction\" : \"Start from Plano, TX USA\"\n      }, {\n        \"distance\" : {\n          \"metric\" : 43,\n          \"text\" : 26,\n          \"value\" : 42514\n        },\n        \"duration\" : {\n          \"text\" : \"53 m\",\n          \"value\" : 3216\n        },\n        \"instruction\" : \"Drive\"\n      }, {\n        \"duration\" : {\n          \"text\" : \"30 m\",\n          \"value\" : 1800\n        },\n        \"instruction\" : \"Break\"\n      } ],\n      \"break_points\" : [ [ 33.02079, -96.69925 ] ],\n      \"stops\" : [ {\n        \"additionalServices\" : \"\",\n        \"amenities\" : \"Parking, Truck\",\n        \"businessesName\" : \"Rodeway Inn\",\n        \"city\" : \"Sandusky\",\n        \"contactName\" : \"\",\n        \"fax\" : \"(419) 626-4118\",\n        \"fuelLanes\" : -1,\n        \"highway\" : \"\",\n        \"latitude\" : 41.4465332,\n        \"longitude\" : -82.69683075,\n        \"parkingSpots\" : \"\",\n        \"paymentMethods\" : \"\",\n        \"phone1\" : \"(419) 626-6852\",\n        \"phone2\" : \"\",\n        \"phone3\" : \"\",\n        \"postalCode\" : \"\",\n        \"restIndex\" : \"1\",\n        \"showers\" : -1,\n        \"state\" : \"OH\",\n        \"stopId\" : 5254,\n        \"streetAddress\" : \"1021 Cleveland Rd.\",\n        \"truckServiceBays\" : -1,\n        \"type\" : \"motels\",\n        \"webAddress\" : \"\"\n      } ]\n    },\n    \"tolls\" : [ {\n      \"cashCost\" : false,\n      \"creditCardCost\" : false,\n      \"currency\" : \"USD\",\n      \"discountCarDetails\" : false,\n      \"discountCarType\" : false,\n      \"discountTruckDetails\" : false,\n      \"discountTrucks\" : false,\n      \"height\" : \"No\",\n      \"id\" : 131030,\n      \"lat\" : 33.00225,\n      \"licensePlateCost\" : 2.01,\n      \"licensePlatePrimary\" : \"ZipCash\",\n      \"licensePlateSecondary\" : false,\n      \"lng\" : -96.77585,\n      \"name\" : \"Coit Main Lane Gantry (MLP7)\",\n      \"prepaidCardCost\" : 1.34,\n      \"road\" : \"President George Bush Tpke\",\n      \"state\" : \"Texas\",\n      \"tagCost\" : 1.34,\n      \"tagPriCost\" : 1.34,\n      \"tagPrimary\" : [ \"TxTAG\", \"TollTag\", \"EZ TAG\", \"K-Tag\" ],\n      \"tagSecCost\" : false,\n      \"tagSecondary\" : [ ],\n      \"type\" : \"barrier\"\n    }, {\n      \"cashCost\" : false,\n      \"creditCardCost\" : false,\n      \"currency\" : \"USD\",\n      \"discountCarDetails\" : false,\n      \"discountCarType\" : false,\n      \"discountTruckDetails\" : false,\n      \"discountTrucks\" : false,\n      \"height\" : \"No\",\n      \"id\" : 131030,\n      \"lat\" : 33.00225,\n      \"licensePlateCost\" : 2.01,\n      \"licensePlatePrimary\" : \"ZipCash\",\n      \"licensePlateSecondary\" : false,\n      \"lng\" : -96.77585,\n      \"name\" : \"Coit Main Lane Gantry (MLP7)\",\n      \"prepaidCardCost\" : 1.34,\n      \"road\" : \"President George Bush Tpke\",\n      \"state\" : \"Texas\",\n      \"tagCost\" : 1.34,\n      \"tagPriCost\" : 1.34,\n      \"tagPrimary\" : [ \"TxTAG\", \"TollTag\", \"EZ TAG\", \"K-Tag\" ],\n      \"tagSecCost\" : false,\n      \"tagSecondary\" : [ ],\n      \"type\" : \"barrier\"\n    } ]\n  } ],\n  \"status\" : \"OK\"\n}";
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<GmapResponse>(exampleJson)
            : default(GmapResponse);
            //TODO: Change the data returned
            return new ObjectResult(example);
        }

        /// <summary>
        /// HERE Maps Routes
        /// </summary>
        /// <remarks>&lt;p&gt;HTTP Request for trucks, buses, RVs, cars, SUV, pick-ups, motorcycles&lt;/p&gt;&lt;p&gt;For trucks you should specify truck weight, wherever possible. Some bridges and tunnels restrict trucks based on weight. If you are transporting HAZMAT material, please specify material type. If you do not specify HAZMAT restrictions and weight restrictions, none will be applied.&lt;/p&gt;</remarks>
        /// <param name="body"></param>
        /// <response code="200">200 response</response>
        [HttpPost]
        [Route("//here")]
        [Authorize(AuthenticationSchemes = ApiKeyAuthenticationHandler.SchemeName)]
        [ValidateModelState]
        [SwaggerOperation("HerePost")]
        [SwaggerResponse(statusCode: 200, type: typeof(HereResponse), description: "200 response")]
        public virtual IActionResult HerePost([FromBody]HereRequestBody body)
        { 
            //TODO: Uncomment the next line to return response 200 or use other options such as return this.NotFound(), return this.BadRequest(..), ...
            // return StatusCode(200, default(HereResponse));

            string exampleJson = null;
            exampleJson = "{\n  \"summary\" : {\n    \"fuelEfficiency\" : {\n      \"city\" : 24,\n      \"hwy\" : 30,\n      \"units\" : \"mpg\"\n    },\n    \"route\" : [ {\n      \"address\" : \"Main St, Dallas, TX 75201, United States\",\n      \"location\" : {\n        \"lat\" : 32.78165,\n        \"lng\" : -96.79448\n      }\n    }, {\n      \"address\" : \"Plano, TX, United States\",\n      \"location\" : {\n        \"lat\" : 33.02079,\n        \"lng\" : -96.69925\n      }\n    }, {\n      \"address\" : \"Allen, TX, United States\",\n      \"location\" : {\n        \"lat\" : 33.10144,\n        \"lng\" : -96.67449\n      }\n    }, {\n      \"address\" : \"Addison, TX, United States\",\n      \"location\" : {\n        \"lat\" : 32.95398,\n        \"lng\" : -96.81769\n      }\n    } ],\n    \"rates\" : {\n      \"CAD\" : 1.342395,\n      \"INR\" : 75.49545,\n      \"MXN\" : 21.748097,\n      \"USD\" : 1\n    },\n    \"fuelPrice\" : \"{\\"currency\\":\\"USD\\",\\"value\\":2.79}\",\n    \"share\" : \"{}\",\n    \"departure_time\" : 1.551541566E9,\n    \"vehicleType\" : \"2AxlesAuto\"\n  },\n  \"routes\" : [ {\n    \"summary\" : {\n      \"duration\" : \"{\\"metric\\":\\"72.7 km\\",\\"text\\":\\"45.2 mi\\",\\"value\\":72731}\",\n      \"note\" : [ ],\n      \"distance\" : \"{\\"text\\":\\"1 h 2 min\\",\\"value\\":3742}\",\n      \"name\" : \"US-75\",\n      \"hasTolls\" : true,\n      \"diffs\" : \"{\\"cheapest\\":\\"2.63,\\",\\"fastest\\":0}\",\n      \"url\" : \"https://www.google.com/maps/?saddr=32.781643,-96.7944781&daddr=32.7839434,-96.7915463+to:32.789104,-96.7916107+to:33.0207898,-96.6992516+to:33.1014399,-96.6744947+to:33.007983,-96.7079687+to:32.9539847,-96.81769&via=1,2,3,4,5\"\n    },\n    \"costs\" : {\n      \"cash\" : false,\n      \"creditCard\" : false,\n      \"fuel\" : 4.31,\n      \"licensePlate\" : 3.69,\n      \"otherCost\" : 10,\n      \"prepaidCard\" : 2.46,\n      \"tag\" : 2.46\n    },\n    \"territoryMileage\" : \"\",\n    \"directions\" : [ {\n      \"distance\" : 29,\n      \"duration\" : 50,\n      \"html_instructions\" : \"Head toward <span class=\\"toward_street\\">S Lamar St</span> on <span class=\\"street\\">Main St</span>. <span class=\\"distance-description\\">Go for <span class=\\"length\\">95 ft</span>.</span>\",\n      \"maneuver\" : \"forward\",\n      \"note\" : [ ],\n      \"position\" : {\n        \"latitude\" : 32.7795011,\n        \"longitude\" : -96.8045704\n      }\n    } ],\n    \"herePath\" : [ 32.7795011, -96.8045704, 32.7795553, -96.8042707, 32.7810788, \"-96.8046463,\", \"...\" ],\n    \"hos\" : {\n      \"summary\" : \"{\\"rulesParam\\":{\\"drivingHoursBeforeEndOfWorkDay\\":11,\\"dutyHoursBeforeEndOfWorkDay\\":11,\\"dutyHoursBeforeRestBreak\\":7.5,\\"rule\\":60,\\"timeRemaining\\":60},\\"total_break_duration\\":{\\"text\\":null,\\"value\\":0},\\"total_distance\\":{\\"metric\\":73,\\"text\\":46,\\"value\\":73302},\\"total_drive_duration\\":{\\"text\\":\\"1 h 23 m\\",\\"value\\":5004},\\"total_duration\\":{\\"text\\":\\"1 h 23 m\\",\\"value\\":5004}}\",\n      \"data\" : [ {\n        \"instruction\" : \"Start from Plano, TX USA\"\n      }, {\n        \"distance\" : {\n          \"metric\" : 43,\n          \"text\" : 26,\n          \"value\" : 42514\n        },\n        \"duration\" : {\n          \"text\" : \"53 m\",\n          \"value\" : 3216\n        },\n        \"instruction\" : \"Drive\"\n      }, {\n        \"duration\" : {\n          \"text\" : \"30 m\",\n          \"value\" : 1800\n        },\n        \"instruction\" : \"Break\"\n      } ],\n      \"break_points\" : [ [ 33.02079, -96.69925 ] ],\n      \"stops\" : [ {\n        \"additionalServices\" : \"\",\n        \"amenities\" : \"Parking, Truck\",\n        \"businessesName\" : \"Rodeway Inn\",\n        \"city\" : \"Sandusky\",\n        \"contactName\" : \"\",\n        \"fax\" : \"(419) 626-4118\",\n        \"fuelLanes\" : -1,\n        \"highway\" : \"\",\n        \"latitude\" : 41.4465332,\n        \"longitude\" : -82.69683075,\n        \"parkingSpots\" : \"\",\n        \"paymentMethods\" : \"\",\n        \"phone1\" : \"(419) 626-6852\",\n        \"phone2\" : \"\",\n        \"phone3\" : \"\",\n        \"postalCode\" : \"\",\n        \"restIndex\" : \"1\",\n        \"showers\" : -1,\n        \"state\" : \"OH\",\n        \"stopId\" : 5254,\n        \"streetAddress\" : \"1021 Cleveland Rd.\",\n        \"truckServiceBays\" : -1,\n        \"type\" : \"motels\",\n        \"webAddress\" : \"\"\n      } ]\n    },\n    \"tolls\" : [ {\n      \"cashCost\" : false,\n      \"creditCardCost\" : false,\n      \"currency\" : \"USD\",\n      \"discountCarDetails\" : false,\n      \"discountCarType\" : false,\n      \"discountTruckDetails\" : false,\n      \"discountTrucks\" : false,\n      \"height\" : \"No\",\n      \"id\" : 131030,\n      \"lat\" : 33.00225,\n      \"licensePlateCost\" : 2.01,\n      \"licensePlatePrimary\" : \"ZipCash\",\n      \"licensePlateSecondary\" : false,\n      \"lng\" : -96.77585,\n      \"name\" : \"Coit Main Lane Gantry (MLP7)\",\n      \"prepaidCardCost\" : 1.34,\n      \"road\" : \"President George Bush Tpke\",\n      \"state\" : \"Texas\",\n      \"tagCost\" : 1.34,\n      \"tagPriCost\" : 1.34,\n      \"tagPrimary\" : [ \"TxTAG\", \"TollTag\", \"EZ TAG\", \"K-Tag\" ],\n      \"tagSecCost\" : false,\n      \"tagSecondary\" : [ ],\n      \"type\" : \"barrier\"\n    }, {\n      \"cashCost\" : false,\n      \"creditCardCost\" : false,\n      \"currency\" : \"USD\",\n      \"discountCarDetails\" : false,\n      \"discountCarType\" : false,\n      \"discountTruckDetails\" : false,\n      \"discountTrucks\" : false,\n      \"height\" : \"No\",\n      \"id\" : 131030,\n      \"lat\" : 33.00225,\n      \"licensePlateCost\" : 2.01,\n      \"licensePlatePrimary\" : \"ZipCash\",\n      \"licensePlateSecondary\" : false,\n      \"lng\" : -96.77585,\n      \"name\" : \"Coit Main Lane Gantry (MLP7)\",\n      \"prepaidCardCost\" : 1.34,\n      \"road\" : \"President George Bush Tpke\",\n      \"state\" : \"Texas\",\n      \"tagCost\" : 1.34,\n      \"tagPriCost\" : 1.34,\n      \"tagPrimary\" : [ \"TxTAG\", \"TollTag\", \"EZ TAG\", \"K-Tag\" ],\n      \"tagSecCost\" : false,\n      \"tagSecondary\" : [ ],\n      \"type\" : \"barrier\"\n    } ]\n  }, {\n    \"summary\" : {\n      \"duration\" : \"{\\"metric\\":\\"72.7 km\\",\\"text\\":\\"45.2 mi\\",\\"value\\":72731}\",\n      \"note\" : [ ],\n      \"distance\" : \"{\\"text\\":\\"1 h 2 min\\",\\"value\\":3742}\",\n      \"name\" : \"US-75\",\n      \"hasTolls\" : true,\n      \"diffs\" : \"{\\"cheapest\\":\\"2.63,\\",\\"fastest\\":0}\",\n      \"url\" : \"https://www.google.com/maps/?saddr=32.781643,-96.7944781&daddr=32.7839434,-96.7915463+to:32.789104,-96.7916107+to:33.0207898,-96.6992516+to:33.1014399,-96.6744947+to:33.007983,-96.7079687+to:32.9539847,-96.81769&via=1,2,3,4,5\"\n    },\n    \"costs\" : {\n      \"cash\" : false,\n      \"creditCard\" : false,\n      \"fuel\" : 4.31,\n      \"licensePlate\" : 3.69,\n      \"otherCost\" : 10,\n      \"prepaidCard\" : 2.46,\n      \"tag\" : 2.46\n    },\n    \"territoryMileage\" : \"\",\n    \"directions\" : [ {\n      \"distance\" : 29,\n      \"duration\" : 50,\n      \"html_instructions\" : \"Head toward <span class=\\"toward_street\\">S Lamar St</span> on <span class=\\"street\\">Main St</span>. <span class=\\"distance-description\\">Go for <span class=\\"length\\">95 ft</span>.</span>\",\n      \"maneuver\" : \"forward\",\n      \"note\" : [ ],\n      \"position\" : {\n        \"latitude\" : 32.7795011,\n        \"longitude\" : -96.8045704\n      }\n    } ],\n    \"herePath\" : [ 32.7795011, -96.8045704, 32.7795553, -96.8042707, 32.7810788, \"-96.8046463,\", \"...\" ],\n    \"hos\" : {\n      \"summary\" : \"{\\"rulesParam\\":{\\"drivingHoursBeforeEndOfWorkDay\\":11,\\"dutyHoursBeforeEndOfWorkDay\\":11,\\"dutyHoursBeforeRestBreak\\":7.5,\\"rule\\":60,\\"timeRemaining\\":60},\\"total_break_duration\\":{\\"text\\":null,\\"value\\":0},\\"total_distance\\":{\\"metric\\":73,\\"text\\":46,\\"value\\":73302},\\"total_drive_duration\\":{\\"text\\":\\"1 h 23 m\\",\\"value\\":5004},\\"total_duration\\":{\\"text\\":\\"1 h 23 m\\",\\"value\\":5004}}\",\n      \"data\" : [ {\n        \"instruction\" : \"Start from Plano, TX USA\"\n      }, {\n        \"distance\" : {\n          \"metric\" : 43,\n          \"text\" : 26,\n          \"value\" : 42514\n        },\n        \"duration\" : {\n          \"text\" : \"53 m\",\n          \"value\" : 3216\n        },\n        \"instruction\" : \"Drive\"\n      }, {\n        \"duration\" : {\n          \"text\" : \"30 m\",\n          \"value\" : 1800\n        },\n        \"instruction\" : \"Break\"\n      } ],\n      \"break_points\" : [ [ 33.02079, -96.69925 ] ],\n      \"stops\" : [ {\n        \"additionalServices\" : \"\",\n        \"amenities\" : \"Parking, Truck\",\n        \"businessesName\" : \"Rodeway Inn\",\n        \"city\" : \"Sandusky\",\n        \"contactName\" : \"\",\n        \"fax\" : \"(419) 626-4118\",\n        \"fuelLanes\" : -1,\n        \"highway\" : \"\",\n        \"latitude\" : 41.4465332,\n        \"longitude\" : -82.69683075,\n        \"parkingSpots\" : \"\",\n        \"paymentMethods\" : \"\",\n        \"phone1\" : \"(419) 626-6852\",\n        \"phone2\" : \"\",\n        \"phone3\" : \"\",\n        \"postalCode\" : \"\",\n        \"restIndex\" : \"1\",\n        \"showers\" : -1,\n        \"state\" : \"OH\",\n        \"stopId\" : 5254,\n        \"streetAddress\" : \"1021 Cleveland Rd.\",\n        \"truckServiceBays\" : -1,\n        \"type\" : \"motels\",\n        \"webAddress\" : \"\"\n      } ]\n    },\n    \"tolls\" : [ {\n      \"cashCost\" : false,\n      \"creditCardCost\" : false,\n      \"currency\" : \"USD\",\n      \"discountCarDetails\" : false,\n      \"discountCarType\" : false,\n      \"discountTruckDetails\" : false,\n      \"discountTrucks\" : false,\n      \"height\" : \"No\",\n      \"id\" : 131030,\n      \"lat\" : 33.00225,\n      \"licensePlateCost\" : 2.01,\n      \"licensePlatePrimary\" : \"ZipCash\",\n      \"licensePlateSecondary\" : false,\n      \"lng\" : -96.77585,\n      \"name\" : \"Coit Main Lane Gantry (MLP7)\",\n      \"prepaidCardCost\" : 1.34,\n      \"road\" : \"President George Bush Tpke\",\n      \"state\" : \"Texas\",\n      \"tagCost\" : 1.34,\n      \"tagPriCost\" : 1.34,\n      \"tagPrimary\" : [ \"TxTAG\", \"TollTag\", \"EZ TAG\", \"K-Tag\" ],\n      \"tagSecCost\" : false,\n      \"tagSecondary\" : [ ],\n      \"type\" : \"barrier\"\n    }, {\n      \"cashCost\" : false,\n      \"creditCardCost\" : false,\n      \"currency\" : \"USD\",\n      \"discountCarDetails\" : false,\n      \"discountCarType\" : false,\n      \"discountTruckDetails\" : false,\n      \"discountTrucks\" : false,\n      \"height\" : \"No\",\n      \"id\" : 131030,\n      \"lat\" : 33.00225,\n      \"licensePlateCost\" : 2.01,\n      \"licensePlatePrimary\" : \"ZipCash\",\n      \"licensePlateSecondary\" : false,\n      \"lng\" : -96.77585,\n      \"name\" : \"Coit Main Lane Gantry (MLP7)\",\n      \"prepaidCardCost\" : 1.34,\n      \"road\" : \"President George Bush Tpke\",\n      \"state\" : \"Texas\",\n      \"tagCost\" : 1.34,\n      \"tagPriCost\" : 1.34,\n      \"tagPrimary\" : [ \"TxTAG\", \"TollTag\", \"EZ TAG\", \"K-Tag\" ],\n      \"tagSecCost\" : false,\n      \"tagSecondary\" : [ ],\n      \"type\" : \"barrier\"\n    } ]\n  } ],\n  \"status\" : \"OK\"\n}";
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<HereResponse>(exampleJson)
            : default(HereResponse);
            //TODO: Change the data returned
            return new ObjectResult(example);
        }
    }
}
